local DoSlam
freeslot("sfx_cepun1")
sfxinfo[sfx_cepun1].caption = "Whish"
freeslot("sfx_cepun2")
sfxinfo[sfx_cepun2].caption = "Whaash"
freeslot("sfx_cepun3")
sfxinfo[sfx_cepun3].caption = "Wheesh"
freeslot("sfx_cepun4")
sfxinfo[sfx_cepun4].caption = "Baam"
sfxinfo[sfx_cepun4].flags = $|SF_X2AWAYSOUND
freeslot("sfx_cefire")
sfxinfo[sfx_cefire].caption = "Eruption"
sfxinfo[sfx_cefire].flags = $|SF_X2AWAYSOUND
freeslot("sfx_ceuppr")
sfxinfo[sfx_ceuppr].caption = "Whoosh"
freeslot("sfx_ceshok")
sfxinfo[sfx_ceshok].caption = "Sho-ken!"
freeslot("sfx_cehit1")
sfxinfo[sfx_cehit1].caption = "Damage"
sfxinfo[sfx_cehit1].flags = $|SF_X2AWAYSOUND
freeslot("sfx_cehit2")
sfxinfo[sfx_cehit2].caption = "Damage"
sfxinfo[sfx_cehit2].flags = $|SF_X2AWAYSOUND
freeslot("sfx_cehit3")
sfxinfo[sfx_cehit3].caption = "Damage"
sfxinfo[sfx_cehit3].flags = $|SF_X2AWAYSOUND
sfxinfo[sfx_cehit3].singular = true
freeslot("sfx_ceboom")
sfxinfo[sfx_ceboom].caption = "Boom"
sfxinfo[sfx_ceboom].flags = $|SF_X2AWAYSOUND
sfxinfo[sfx_ceboom].singular = true
sfxinfo[sfx_bgxpld].singular = true

local P_SafeTeleportMove = function(mo, x, y, z)
	local action = P_SetOrigin or P_TeleportMove
	action(mo, x, y, z)
end

// Abilites table for Kirby to eat
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
// Needle
kirbyabilitytable["cacee"] = 6

//Fang showdown stuff
local caceey = -175
hud.add(function(v, player, cam)
	if player.mo and player.mo.valid and player.mo.caceefang and player.mo.caceefang.valid
		hud.disable("score")
		hud.disable("time")
		hud.disable("rings")
		hud.disable("lives")
		v.drawFill(0,0+caceey, 500, 150, 31|V_SNAPTOLEFT)
		v.drawFill(0,50-caceey, 500, 150, 31|V_SNAPTOLEFT)
		if caceey < -100
			caceey = $+1
		end
	elseif caceey > -175
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		v.drawFill(0,0+caceey, 500, 150, 31|V_SNAPTOLEFT)
		v.drawFill(0,50-caceey, 500, 150, 31|V_SNAPTOLEFT)
		caceey = $-1
	end
end)
addHook("MapLoad", do
	if not multiplayer and not netgame and not modeattacking and gamemap == 15
	and mapheaderinfo[gamemap].lvlttl == "Arid Canyon"
	and mapheaderinfo[gamemap].actnum == 3 and players[0] and players[0].valid
	and players[0].mo and players[0].mo.valid and players[0].mo.skin == "cacee"
	and not (players[1] and players[1].valid)
		for fang in mobjs.iterate()
			if fang.type == MT_FANG
				caceey = -175
				players[0].mo.caceefang = fang
				players[0].mo.state = S_PLAY_CLING
				players[0].mo.angle = ANGLE_225
				players[0].drawangle = ANGLE_225
				players[0].mo.reactiontime = -1
				P_SafeTeleportMove(players[0].mo, fang.x+257*FRACUNIT, fang.y+323*FRACUNIT, fang.z+6*FRACUNIT)
				players[0].mo.z = players[0].mo.floorz
				
				local hat = P_SpawnMobjFromMobj(players[0].mo,0,0,0,MT_CACEE_HAT)
				hat.tracer = players[0].mo
				
				fang.angle = 0
				S_FadeOutStopMusic(4*MUSICRATE)
				
				local dist = R_PointToDist2(players[0].mo.x, players[0].mo.y, fang.x, fang.y)/2
				local thok = P_SpawnMobjFromMobj(players[0].mo,
				P_ReturnThrustX(nil, players[0].drawangle, dist*2/5),
				P_ReturnThrustY(nil, players[0].drawangle, -dist), 0, MT_THOK)
				thok.state = S_INVISIBLE
				thok.angle = ANGLE_270
				players[0].awayviewmobj = thok
				players[0].awayviewtics = -1
			end
		end
	end
end)

//Extra enemy HP
local caceehealth = {
	[MT_GFZFISH] = 1,
	[MT_DETON] = 1,
	[MT_SKIM] = 1,
	[MT_POPUPTURRET] = 1,
	[MT_CRUSHSTACEAN] = 1,
	[MT_BANPYURA] = 1,
	[MT_JETJAW] = 1,
	[MT_VULTURE] = 1,
	[MT_POINTY] = 1,
	[MT_MINUS] = 1,
	[MT_BUMBLEBORE] = 1,
	[MT_BUGGLE] = 1,
	[MT_SPINBOBERT] = 1,
	
	[MT_REDCRAWLA] = 3,
	[MT_REDBUZZ] = 3
}

//Invincibile enemies in the tutorial
local caceetutinv = {
	[MT_REDCRAWLA] = true,
	[MT_REDBUZZ] = true,
	[MT_FACESTABBER] = true
}

local UPPERTIME = 10 //Uppercut multihit window
local BURNFACTOR = TICRATE*3
local BURNTHRESHOLD = tr_trans40*BURNFACTOR
local BURNINCREASE = tr_trans80*BURNFACTOR

//Cacee hat object for the Fang showdown
freeslot("MT_CACEE_HAT")
mobjinfo[MT_CACEE_HAT] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mobj)
	if mobj.state == S_INVISIBLE
	and mobj.tracer and mobj.tracer.valid
		if mobj.tracer.state == S_PLAY_CLING
			A_CapeChase(mobj, 26*FRACUNIT+1, 0)
			mobj.flags2 = $|MF2_LINKDRAW
		else
			P_InstaThrust(mobj, mobj.tracer.angle+ANGLE_45, -4*mobj.scale)
			P_SetObjectMomZ(mobj, FRACUNIT, false)
			mobj.skin = mobj.tracer.skin
			mobj.state = S_TAILSOVERLAY_STAND
			mobj.tracer = nil
			mobj.flags = $&~MF_NOGRAVITY
			mobj.flags2 = $&~MF2_LINKDRAW
			mobj.fuse = 3*TICRATE
		end
	elseif mobj.state != S_INVISIBLE
		mobj.momz = $-P_GetMobjGravity(mobj)/2
		mobj.rollangle = $+(mobj.state == S_TAILSOVERLAY_0DEGREES and -ANGLE_11hh or ANGLE_11hh)
	end
end, MT_CACEE_HAT)

//Cacee Explode object
//Handles enemies exploding when dying, allowing the actual enemy to do their
//normal death routine
function A_CaceeExplode(mobj)
	mobj.scale = mobj.originscale
	mobj.rollangle = 0
	A_ForceStop(mobj)
	S_StopSound(mobj)
	S_StartSound(mobj, mobj.info.deathsound)
end

freeslot("MT_CACEE_EXPLODE", "S_CACEE_EXPLODE")
states[S_CACEE_EXPLODE] = {SPR_BARX, 0|FF_FULLBRIGHT, 0, A_CaceeExplode, 0, 0, S_FBOMB_EXPL1}
mobjinfo[MT_CACEE_EXPLODE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	deathstate = S_CACEE_EXPLODE,
	xdeathstate = S_CACEE_EXPLODE,
	deathsound = sfx_ceboom,
	reactiontime = 0,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}

addHook("MobjThinker", function(mobj)
	if not mobj.health or not mobj.cusval then return end
	mobj.rollangle = $ + ANGLE_22h*mobj.cusval
end, MT_CACEE_EXPLODE)

addHook("MobjFuse", function(mobj)
	if mobj.state < S_FBOMB_EXPL1 or mobj.state > S_FBOMB_EXPL6
		P_KillMobj(mobj)
	end
	return true
end, MT_CACEE_EXPLODE)

//Cacee hit state
freeslot("S_CACEE_HIT1", "S_CACEE_HIT2", "S_CACEE_HIT3", "S_CACEE_HIT4",
"SPR_CEX1", "SPR_CEX2")
states[S_CACEE_HIT1] = {SPR_CEX1, FF_ANIMATE|FF_FULLBRIGHT, 6, nil, 5, 1, S_CACEE_HIT2}
states[S_CACEE_HIT2] = {SPR_CEX1, F|FF_TRANS30|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 0, 0, S_CACEE_HIT3}
states[S_CACEE_HIT3] = {SPR_CEX1, F|FF_TRANS70|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 0, 0, S_NULL}
states[S_CACEE_HIT4] = {SPR_CEX2, FF_ANIMATE|FF_FULLBRIGHT, 31, nil, 30, 1, S_NULL}

//Cacee Flash object
//Handles enemy flashing and stun when delt partial damage by Cacee
freeslot("MT_CACEE_FLASH")
mobjinfo[MT_CACEE_FLASH] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mobj)
	if not mobj.target return end
	if not (mobj.target and mobj.target.valid and not mobj.target.health)
		A_CapeChase(mobj,0,0)
	end
	if not (mobj and mobj.valid) return end
	if mobj.fuse%2 or mobj.fuse <= TICRATE/2-7
		mobj.state = S_INVISIBLE
	elseif mobj.target and mobj.target.valid
		if mobj.target.health
			if mobj.target.type == MT_ROSY
				mobj.target.state = S_ROSY_PAIN
			end
			P_SetMobjStateNF(mobj, mobj.target.state)
			mobj.tics = -1
			mobj.colorized = true
			mobj.color = SKINCOLOR_SUPERSILVER1
		else
			mobj.target.flags = $&~MF_NOTHINK
			P_KillMobj(mobj)
		end
	end
end, MT_CACEE_FLASH)
addHook("MobjFuse", function(mobj)
	if mobj.target and mobj.target.valid
		mobj.target.flags = $&~MF_NOTHINK
	end
end, MT_CACEE_FLASH)

//Followitem used for fire resistence
freeslot("MT_CACEE_BURN")
mobjinfo[MT_CACEE_BURN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	dispoffset = 2,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}
addHook("FollowMobj", function(player, mobj)
	local mo = player.mo
	if not (mo and mo.valid and mobj and mobj.valid) return true end
	mobj.flags2 = $&~MF2_LINKDRAW
	
	//Burn Overlay
	if (player.caceeburn and not mo.colorized)
	or (player.solchar and player.solchar.istransformed and not player.powers[pw_super]
	and (mo.state < S_PLAY_SUPER_TRANS1 or mo.state > S_PLAY_SUPER_TRANS3))
		mobj.skin = mo.skin
		
		mobj.scale = mo.scale
		mobj.radius = mo.radius
		mobj.height = mo.height
		mobj.flags2 = mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		mobj.eflags = mo.eflags&MFE_VERTICALFLIP
		
		mobj.rollangle = mo.rollangle
		mobj.mirrored = mo.mirrored
		mobj.spritexscale = mo.spritexscale
		mobj.spriteyscale = mo.spriteyscale
		mobj.spritexoffset = mo.spritexoffset
		mobj.spriteyoffset = mo.spriteyoffset
		mobj.renderflags = mo.renderflags
		mobj.blendmode = mo.blendmode
		
		//Sol form effects
		if player.solchar and player.solchar.istransformed
			//Particles
			if (not rusheffects or rusheffects.value)
			and (P_RandomRange(3, 0) == 0)
				local fire = P_SpawnMobjFromMobj(mo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				P_SetObjectMomZ(fire, P_RandomRange(1,3)*FRACUNIT, false)
				fire.color = mobj.color
				fire.colorized = true
				fire.blendmode = AST_ADD
			end
			mobj.colorized = false
			
			//Smoke
			if mo.state == S_PLAY_RUN and mo.eflags & MFE_TOUCHWATER
			and not (mo.eflags & (MFE_UNDERWATER|MFE_TOUCHLAVA))
			and P_IsObjectOnGround(mo)
				local smoke = P_SpawnMobjFromMobj(mo,25*(P_RandomFixed()-(FRACUNIT/2)),
				50*(P_RandomFixed()-(FRACUNIT/2)),0,MT_SMOKE)
				smoke.momx = mo.momx/2
				smoke.momy = mo.momy/2
				smoke.momz = mo.momz/2
				if player.solchar.istransformed % 4 == 0
					S_StartSoundAtVolume(mo, sfx_s3k4b, 128)
				end
			end
			
			//Pulse
			if player.solchar.istransformed % 10 == 0
			and mobj.color == SKINCOLOR_FLAME
				local ghost = P_SpawnGhostMobj(mo)
				if ghost.tracer
					P_RemoveMobj(ghost.tracer)
				end
				
				ghost.scalespeed = FixedMul($, ghost.scale)
				ghost.destscale = $*32
				
				ghost.target = mo
				ghost.tracer = mo
				ghost.flags2 = $ | MF2_LINKDRAW
				player.caceeghost = ghost
				
			elseif player.caceeghost and player.caceeghost.valid
				if mobj.color != SKINCOLOR_FLAME
					P_RemoveMobj(player.caceeghost)
					player.caceeghost = nil
				else
					A_CapeChase(player.caceeghost,
					1-((player.solchar.istransformed%9)<<FRACBITS))
				end
			end
			
			if mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_GLIDE
				mobj.state = S_TAILSOVERLAY_MINUS30DEGREES
				
				if mo.state == S_PLAY_GLIDE
					if mobj.color != SKINCOLOR_SANDY
						mobj.cusval = 0
						mobj.color = SKINCOLOR_SANDY
					end
					
					mobj.frame = $ ^^ FF_VERTICALFLIP
					mobj.spritexscale = $*7/4
					mobj.spriteyscale = $*4/5
				else
					if mobj.color != SKINCOLOR_RASPBERRY
						mobj.cusval = 0
						mobj.color = SKINCOLOR_RASPBERRY
					end
					
					mobj.spritexscale = $*5/4
					mobj.spriteyscale = $*3/2
				end
			elseif mo.state >= S_PLAY_FIRE and mo.state <= S_PLAY_MELEE_FINISH
				if mobj.color != SKINCOLOR_RED
					mobj.cusval = 0
					mobj.color = SKINCOLOR_RED
				end
				
				mobj.state = S_TAILSOVERLAY_PLUS60DEGREES
				mobj.spritexscale = $*4/3
			else
				if mobj.color != SKINCOLOR_FLAME
					mobj.cusval = 0
					mobj.color = SKINCOLOR_FLAME
				end
				
				mobj.state = S_TAILSOVERLAY_PLUS30DEGREES
				mobj.spritexscale = $*7/4
				mobj.spriteyscale = $*5/4
			end
			mobj.blendmode = AST_ADD
			mobj.renderflags = $|RF_FULLBRIGHT
			
			//Transparency
			if mobj.cusval < 8
				mobj.cusval = $+2
				mobj.frame = $ | ((10 - mobj.cusval)<<FF_TRANSSHIFT)
			else
				mobj.frame = $ | FF_TRANS20
			end
		else
			mobj.cusval = 0
			
			mobj.color = G_GametypeHasTeams() and player.ctfteam == 2 and SKINCOLOR_VAPOR or SKINCOLOR_KETCHUP
			mobj.colorized = true
			
			mobj.state = mo.state
			mobj.frame = mo.frame|(min(max(NUMTRANSMAPS-player.caceeburn/BURNFACTOR,0),tr_trans90)<<FF_TRANSSHIFT)
			mobj.sprite2 = mo.sprite2
			mobj.angle = player.drawangle
		end	
		
	//Nothing!
	elseif mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
		mobj.cusval = 0
	end
end, MT_CACEE_BURN)

//Bashable Cactus Pot for BattleMod
freeslot("MT_CACEE_POT", "S_CACEE_POT_SPAWN", "S_CACEE_POT_IDLE", "S_CACEE_POT_DIE", "SPR_KCPT")
mobjinfo[MT_CACEE_POT] = {
	name = "Pot of Pain",
	spawnstate = S_CACEE_POT_SPAWN,
	spawnhealth = TICRATE*10,
	deathstate = S_CACEE_POT_DIE,
	seesound = sfx_cdfm41,
	attacksound = sfx_s3kc3s,
	painsound = sfx_jshard,
	deathsound = sfx_cdfm16,
	mass = DMG_SPIKE,
	radius = 24*FRACUNIT,
	height = 72*FRACUNIT,
	flags = MF_SLIDEME|MF_RUNSPAWNFUNC|MF_SPECIAL
}
states[S_CACEE_POT_SPAWN] = {SPR_KCPT, FF_ANIMATE|A, 14, A_PlaySeeSound, 6,  2, S_CACEE_POT_IDLE}
states[S_CACEE_POT_IDLE] = {SPR_KCPT, G, -1, nil, 0, 0, S_CACEE_POT_IDLE}
states[S_CACEE_POT_DIE] = {SPR_KCPT, FF_ANIMATE|G, 14, A_Pain, 6,  2, S_XPLD1}
addHook("MobjSpawn", function(mobj)
	if CBW_Battle
		CBW_Battle.CreateBashable(mobj, 25, 2, false, false)
	end
	mobj.name = mobj.info.name
end, MT_CACEE_POT)
local BashableThinkerNOTHOK = function(mo)
	--Gate
	if not(mo and mo.valid) then return end
	if not(mo.battleobject) then return end
	if mo.hitstun_tics
		mo.hitstun_tics = max(0, $-1)
		if mo.hitstun_restoreflags == nil
			mo.hitstun_restoreflags = mo.flags
		end
		mo.flags = $|MF_SCENERY|MF_NOGRAVITY
		if mo.hitstun_tics
			mo.spritexoffset = P_RandomRange(8, -8) * FRACUNIT
			mo.spriteyoffset = P_RandomRange(2, 2) * FRACUNIT
		else
			mo.spritexoffset = 0
			mo.spriteyoffset = 0
			mo.flags = mo.hitstun_restoreflags
			mo.hitstun_restoreflags = nil
		end
		return true -- Pause thinker
	end
	if mo.pain_tics then
		mo.pain_tics = $-1
		if mo.pain_tics&1 then 
			mo.flags2 = $|MF2_DONTDRAW
		else
			mo.flags2 = $&~MF2_DONTDRAW
		end
	end
	--Correct our target to reflect "owner"
	if (mo.target) and not(mo.target.player) then --Bashables should only have player objects as their target.
		--Pushables will set other pushables as their target on collision, and this can cause problems
		if mo.target.target and mo.target.target.player then --But, if our target's target is a player object, due to a chain reaction...
			mo.target = mo.target.target --...Then we may as well borrow that target, so players receive proper credit for chain reactions
		else --Otherwise, we'll just clear our target value
			mo.target = nil
		end
	end
	--Do physics
	local trueweight = FixedMul(mo.weight,mo.scale) --Weight must reflect object scale
	local speed = FixedHypot(mo.momx,mo.momy) --Get current movement speed
	local threshold = trueweight*6 --Speed necessary before the object's velocity is considered "threatening"
	--Ball physics
	if mo.smooth then
		mo.friction = mo.momentum --Friction reflects "push momentum" at all times
		--Slope physics
		if (mo.standingslope)
			then
			local slope = mo.standingslope
			local m = FixedDiv(slope.zdelta,trueweight)
			P_Thrust(mo,slope.xydirection,m)
		end
	end
	if mo.pushed_last and not(mo.battle_atk) then
		mo.pushtics = $+1
	end
	--Object is moving at high speeds
	if speed/*+abs(mo.momz)*/ > threshold and(not(mo.sentient) or mo.pushed_last) then
		--Object can deal damage to other players
		mo.battle_atk = 1
		mo.friction = mo.momentum
		--VFX
		P_SpawnGhostMobj(mo)
		--Object rotation is a visual indicator of movespeed
		mo.angle = $+FixedMul(speed,trueweight)/FRACUNIT*ANG1
		mo.pushtics = $+speed/FRACUNIT
		--Sliding FX
		if not(mo.smooth) and P_IsObjectOnGround(mo) and mo.pushtics >= 32
			mo.pushtics = 0
			S_StartSound(mo,sfx_s3k47)
			--Do dust particles
			local r = function()
				local w = mo.radius/FRACUNIT
				return P_RandomRange(-w,w)*FRACUNIT
			end
			P_SpawnMobj(mo.x+r(),mo.y+r(),mo.z,MT_DUST)
		end
	elseif P_IsObjectOnGround(mo) or mo.pushtics > 15 --Object is idle or not moving quickly. Keep our slate clean
		mo.pushed = nil
		mo.pushed_last = nil
		if not(mo.sentient) then
			mo.target = nil
		end
		mo.pushtics = 0
		mo.battle_atk = 0
		mo.flags = mo.info.flags
		mo.pain = false
	end
end

local POT_SPAWN_TIME = TICRATE/2
addHook("MobjThinker", function(mobj)
	if CBW_Battle and mobj.health
		BashableThinkerNOTHOK(mobj)
		mobj.battle_atk = max($,1)
		mobj.health = $-1
		local spawningpot = mobj.health > (mobjinfo[MT_CACEE_POT].spawnhealth - POT_SPAWN_TIME)
		if mobj.pushcooldown
			mobj.pushcooldown = $-1
		end
		if spawningpot
			A_ForceStop(mobj)
		end
		if (not mobj.therealcacee) or (mobj.therealcacee.player and mobj.therealcacee.player.playerstate)
			mobj.health = 0
		end
	elseif not (mobj.health or mobj.dyingpot)
		mobj.dyingpot = true
		S_StartSound(mobj, sfx_statu1)
		S_StopSoundByID(mobj, mobj.info.attacksound)
		mobj.colorized = false
		mobj.momx = 0
		mobj.momy = 0
		mobj.momz = 0
		mobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
		mobj.battleobject = 0
		P_KillMobj(mobj)
	end
	
	//Remember your original owner for passive attacks
	if not mobj.target
		mobj.target = mobj.therealcacee
	end
	
	if mobj.state == S_XPLD1
		mobj.shadowscale = 0
	end
	
	if mobj.health > 0 and mobj.health <= TICRATE*4
		if (mobj.health%12 and mobj.health > TICRATE*2)
		or (mobj.health%3 and mobj.health <= TICRATE*2)
			mobj.colorized = false
			mobj.frame = $&~FF_TRANSMASK
		else
			S_StopSoundByID(mobj, mobj.info.attacksound)
			S_StartSoundAtVolume(mobj, mobj.info.attacksound, 192)
			mobj.colorized = true
			mobj.frame = $|FF_TRANS90
		end
	end
end, MT_CACEE_POT)
addHook("ShouldDamage", function(trg, inf, src, dmg, dmgtype)
	if inf and inf.valid and inf.type == MT_CACEE_POT
	and inf.target and inf.target.valid and inf.target.player
	and trg and trg.valid and trg.player
		if dmgtype == DMG_CRUSHED
			return false
		elseif CBW_Battle and (not CBW_Battle.PlayerCanBeDamaged(trg.player)
		or CBW_Battle.MyTeam(inf.target.player,trg.player))
			return false
		elseif inf.target == trg
			return false
		elseif G_GametypeHasTeams() and inf.target.player.ctfteam == trg.player.ctfteam
			return false
		end
	end
end, MT_PLAYER)
freeslot("SKINCOLOR_MIDNIGHTBLUE")
skincolors[SKINCOLOR_MIDNIGHTBLUE] = {
    name = "Midnight Blue",
    ramp = {153,153,154,154,155,156,157,157,158,159,253,253,253,254,254,31},
    invcolor = SKINCOLOR_CRIMSON,
    invshade = 5,
    chatcolor = 132,
    accessible = false
}

//I/O saving
local function SaveCaceeConfig(player, save)
	if io and player == consoleplayer and save != "0"
		local file = io.openlocal("client/Cacee.dat", "w+")
		if file
			file:write(player.caceehoming.."\n"..player.caceecamera)
			file:close()
		end
	end
end

//caceehoming command
local function caceehoming(player, arg, save)
	if arg
		if arg == "0" or arg == "off"
			player.caceehoming = 0
			SaveCaceeConfig(player, save)
		elseif arg == "1" or arg == "on" or arg == "default"
			player.caceehoming = 1
			SaveCaceeConfig(player, save)
		elseif player.caceehoming
			CONS_Printf(player, "caceehoming [on/off] - If on, Cacee's regular punch will home onto enemies. Currently on.")
		else
			CONS_Printf(player, "caceehoming [on/off] - If on, Cacee's regular punch will home onto enemies. Currently off.")
		end
	elseif player.caceehoming
		CONS_Printf(player, "caceehoming [on/off] - If on, Cacee's regular punch will home onto enemies. Currently on.")
	else
		CONS_Printf(player, "caceehoming [on/off] - If on, Cacee's regular punch will home onto enemies. Currently off.")
	end
end
COM_AddCommand("caceehoming", caceehoming)
COM_AddCommand("caceehoming2", caceehoming, COM_SPLITSCREEN)

//caceecamera command
local function caceecamera(player, arg, save)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "off" or arg == "default"
		or arg == "none" or arg == "disabled"
			player.caceecamera = 0
			SaveCaceeConfig(player, save)
		elseif arg == "1" or arg == "punch" or arg == "punches"
			player.caceecamera = 1
			SaveCaceeConfig(player, save)
		elseif arg == "2" or arg == "uppercut" or arg == "uppercuts"
			player.caceecamera = 2
			SaveCaceeConfig(player, save)
		elseif arg == "3" or arg == "both" or arg == "all"
			player.caceecamera = 3
			SaveCaceeConfig(player, save)
		else
			CONS_Printf(player, "caceecamera - Determines if Cacee's punches and uppercuts are aimed with the camera or not.")
			CONS_Printf(player, "\x81 0: Both are aimed using movement keys or the joystick.")
			CONS_Printf(player, "\x85 1: Only punches are aimed with the camera.")
			CONS_Printf(player, "\x83 2: Only uppercuts are aimed with the camera.")
			CONS_Printf(player, "\x82 3: Both punches and uppercuts are aimed with the camera.")
			CONS_Printf(player, "Currently "..(player.caceecamera or 0)..".")
			--if CBW_Battle then CONS_Printf(player, "\x85 In Battle gametypes, this will be 1 regardless of your setting!") end
		end
	else
		CONS_Printf(player, "caceecamera - Determines if Cacee's punches and uppercuts are aimed with the camera or not.")
		CONS_Printf(player, "\x81 0: Both are aimed using movement keys or the joystick.")
		CONS_Printf(player, "\x85 1: Only punches are aimed with the camera.")
		CONS_Printf(player, "\x83 2: Only uppercuts are aimed with the camera.")
		CONS_Printf(player, "\x82 3: Both punches and uppercuts are aimed with the camera.")
		CONS_Printf(player, "Currently "..(player.caceecamera or 0)..".")
		--if CBW_Battle then CONS_Printf(player, "\x85 In Battle gametypes, punches will ignore this and aim at the camera!") end
	end
end
COM_AddCommand("caceecamera", caceecamera)
COM_AddCommand("caceecamera2", caceecamera, COM_SPLITSCREEN)

//Get the player's input angle
local function getinputangle(player, uppercut)
	local caceecamera = player.caceecamera
	--[[
	if CBW_Battle and CBW_Battle.BattleGametype() and not(player.pflags & PF_ANALOGMODE)
		caceecamera = ($ <= 1) and 1 or 3
	end
	]]
	if player.mo.flags2 & MF2_TWOD or twodlevel
	or player.caceeinputangle == nil
	or (not (player.pflags&PF_ANALOGMODE)
	and (not (player.cmd.forwardmove or player.cmd.sidemove)
	or (caceecamera and ((not uppercut and caceecamera != 2)
	or (uppercut and caceecamera >= 2))) ))
		return player.mo.angle
	elseif player.pflags&PF_ANALOGMODE
	and caceecamera and ((not uppercut and caceecamera != 2)
	or (uppercut and caceecamera >= 2))
		return player.cmd.angleturn<<16
	else
		return player.caceeinputangle
	end
end

//Spawns objects in a circle
local function caceecircle(mobj, mobjtype, amount, ns, zoffset, scale, keepmom, color, vertical, vertangle, amount2)
	local i = 0	while i < amount
		local fa = amount2 and i*(ANGLE_180/(amount2/2)) or i*(ANGLE_180/(amount/2))
		local fa2_ang = mobj.player and getinputangle(mobj.player, true) or mobj.angle
		local fa2 = amount2 and fa-fa2_ang+ANGLE_90+ANGLE_22h or fa --this is very hacky but whatever ~lumy
		local mo = P_SpawnMobjFromMobj(mobj,0,0,zoffset,mobjtype)
		if mo and mo.valid
			local height = mo.height
			mo.scale = scale
			mo.target = mobj
			if mobj.eflags&MFE_VERTICALFLIP
				mo.z = $-(mo.height-height)
			end
			if mobjtype == MT_MINECARTSPARK
				mo.fuse = TICRATE
			end
			if color
				mo.color = color
				mo.colorized = true
			end
			if mo.type == MT_THOK
				mo.colorized = false
				mo.fuse = mo.tics
			end
			if vertical
				mo.momz = FixedMul(sin(fa2),ns)
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				mo.momx = FixedMul(sin(fa2),ns)
				mo.momy = FixedMul(cos(fa2),ns)
			end
			if keepmom
				mo.momx = $+mobj.momx
				mo.momy = $+mobj.momy
				mo.momz = $+mobj.momz
			end
		end
		i = $+1
	end
end

//Cacee erupt state
local function cacceeerupt(mobj, mo)
	local range = (mo.radius*8)>>FRACBITS
	local fire = P_SpawnMobjFromMobj(mobj,
	P_RandomRange(-range, range)<<FRACBITS,
	P_RandomRange(-range, range)<<FRACBITS, 1, MT_FLAMEJETFLAMEB)
	fire.state = S_FIREBALL
	fire.target = mo
	fire.flags = $ | MF_BOUNCE | MF_GRENADEBOUNCE &~ MF_NOGRAVITY &~ MF_PAIN &~ MF_FIRE
	fire.fuse = TICRATE*2
	P_SetObjectMomZ(fire, 8*P_RandomFixed() + 8*FRACUNIT, false)
	P_InstaThrust(fire, P_RandomRange(1, 360)*ANG1, FixedMul(8*P_RandomFixed(), mo.scale))
end
function A_CaceeErupt(mobj)
	if not mobj.fuse then mobj.fuse = TICRATE*2/3 end
	
	local mo = mobj.target
	if not mo then return end
	
	if mobj.fuse > 10
		cacceeerupt(mobj,mo)
	end
	
	if not ((mobj.fuse-1) % 15)
		caceecircle(mobj, MT_FIREBALLTRAIL, 16, 32*mo.scale, 0, mo.scale)
		
		if mobj.fuse < 10
			for i = 1, 8
				cacceeerupt(mobj,mo)
			end
		end
	
		if mo.player and displayplayer == mo.player
			P_StartQuake(16*FRACUNIT, 5)
		end
	end
end
freeslot("S_CACEE_ERUPT")
states[S_CACEE_ERUPT] = {SPR_NULL, 0, 1, A_CaceeErupt, 0, 0, S_CACEE_ERUPT}

//When you hit a thing
local punchknockback = function(player, mobj)
	local mo = player.mo
	if player.caceepunch or mo.state == S_PLAY_TWINSPIN
		local angle = R_PointToAngle2(mobj.x,mobj.y,mo.x-mo.momx,mo.y-mo.momy)
		
		//Punchin'
		if player.caceepunch
			//Vertical
			if P_IsObjectOnGround(mo)
				mo.z = $+P_MobjFlip(mo)
				mo.momz = abs(P_GetMobjGravity(mo))*P_MobjFlip(mo)
			else
				mo.momz = abs(P_GetMobjGravity(mo)*8)*P_MobjFlip(mo)
			end
			
			//Horizontal
			P_InstaThrust(mo, angle, (player.caceepunch < 3 and 20 or 10)*mo.scale)
			if mobj.battleobject and not(mobj.momx or mobj.momy) then
				P_InstaThrust(mobj, angle+ANGLE_180, (player.caceepunch < 3 and 20 or 10)*mo.scale)
			end
			
			//Underwater drag
			if mo.eflags&MFE_UNDERWATER
				mo.momx = $*2/3 mo.momy = $*2/3
			end
			
			//States
			if mo.state != S_PLAY_MELEE_FINISH and player.caceepunch == 1
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
			elseif mo.state != S_PLAY_FIRE_FINISH and player.caceepunch == 2
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
			end
			
		//Uppercuttin'
		elseif mo.state == S_PLAY_TWINSPIN
			//Multihit
			if player.caceeuppertimer and not mobj.player
			and not (player.caceemultihits >= (caceehealth[mobj] or 2)
			and mapheaderinfo[gamemap].caceetutorial and caceetutinv[mobj.type])
				player.pflags = $&~PF_JUMPED
				P_DoJump(player, false)
				player.caceeupperspeed = FixedHypot(mo.momx, mo.momy)
				player.caceeuppermomz = mo.momz
				player.caceeupperangle = player.drawangle
				player.caceeuppertimer = UPPERTIME
				player.caceemultihits = $+1
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				player.pflags = $|PF_FULLSTASIS
				
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_TWINSPIN
				player.panim = PA_DASH
			//Normal hit
			else
				if mo.momz*P_MobjFlip(mo) > 0
					mo.momz = abs($)*P_MobjFlip(mo)/-4
				end
				P_InstaThrust(mo, angle, player.speed)
			end
		end
		
		if not P_IsObjectOnGround(mo)
			player.pflags = $|P_GetJumpFlags(player)
		end
		player.pflags = $&~PF_THOKKED&~PF_SHIELDABILITY
	end
end

local dosprong = function(player)
	local mo = player.mo
	local cansprong = player.caceepunch or mo.state == S_PLAY_GLIDE or mo.state == S_PLAY_MELEE_LANDING
	local cansprongbattle = player.bpatchcaceepunch and player.bpatchcaceeairpunches
	if (mo.state == S_PLAY_ROLL) or not(cansprong or cansprongbattle) then
		return
	end
	mo.momz = $*5/4
	mo.momx = $*5/4
	mo.momy = $*5/4
	S_StartSound(mo, sfx_sprong)
		
	if mo.state != S_PLAY_SPRING and player.powers[pw_noautobrake]
	and player.powers[pw_justsprung]
	and P_IsObjectOnGround(mo)
		S_StartSound(mo, sfx_spin)
		mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		player.caceepunch = 0
		player.bpatchcaceepunch = TICRATE/5
	end
	player.caceepunch = 0
	player.caceethrust = 0
	player.bpatchcaceeairpunches = 0
	player.bpatchcaceepunch = 5
	mo.bpatchcaceetumblepunch = 0
	player.pflags = $ | PF_SPINDOWN
	if not(mo.state == S_PLAY_ROLL) then mo.state = S_PLAY_SPRING end
end

//Custom version of P_NukeEnemies that will hit monitors and spikes
local nukepunch = function(player, radius, candamage, wind)
	local mo = player.mo
	local thokmobj = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	local coneradius = ANG20 + ANG20
	thokmobj.radius = radius
	thokmobj.flags2 = $|MF2_DONTDRAW
	thokmobj.name = candamage and "Spike Rush combo" or "Spike Rush finisher"
	searchBlockmap("objects", function(refmobj, mobj)
		if not (mobj and mobj.valid and mobj.health and mobj != mo)
			return
		end
		
		if candamage
		and (not P_PlayerCanDamage(player, mobj) or mobj.flags&(MF_NOCLIP|MF_NOCLIPTHING))
			return
		end
		
		if wind and (mobj.flags & (MF_NOGRAVITY|MF_MONITOR|MF_SPRING)
		or mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_BLACKEGGMAN or mobj.type == MT_CYBRAKDEMON
		or (mobj.player and P_PlayerInPain(mobj.player)) and mobj.player.secondjump)
			return
		end
		
		if not (mobj.flags & (MF_SHOOTABLE|MF_SPRING) or mobj.battleobject)
		and mobj.type != MT_EGGGUARD and mobj.type != MT_MINUS
		and mobj.type != MT_SALOONDOOR and mobj.type != MT_METALSONIC_BATTLE
		and mobj.type != MT_WALLSPIKE
		and (mobj.type != MT_SPIKE or (P_IsObjectOnGround(mo)
		and not (mo.eflags&MFE_ONGROUND) and player.caceepunch
		and player.caceepunch <= 2))
			return
		end
		
		if mobj.flags & MF_SPRING and (mo.eflags & MFE_SPRUNG or not candamage
		or mobj.info.painchance == -1)
			return
		end

		if mobj.player
			if mobj.player.spectator or mobj.flags&(MF_NOCLIP|MF_NOCLIPTHING)
				return
			elseif not CV_FindVar("friendlyfire").value
			and G_GametypeHasTeams() and mobj.player.ctfteam == player.ctfteam
				return
			elseif G_TagGametype() and (mobj.player.pflags & PF_TAGIT) == (player.pflags & PF_TAGIT)
				return
			elseif not CV_FindVar("friendlyfire").value and not G_RingSlingerGametype()
			and not (CBW_Battle and CBW_Battle.BattleGametype())
				return
			elseif not candamage and not P_IsObjectOnGround(mobj)
				return
			end
		end

		if abs(mo.x - mobj.x) > radius or abs(mo.y - mobj.y) > radius or abs(mo.z - mobj.z) > radius
			return // Workaround for possible integer overflow in the below -Red
		end

		if FixedHypot(R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y),
		(mo.z - mobj.z)*(wind and 4 or 2)) > (mobj.player and not wind and not candamage and radius*2/3 or radius)
			return
		end

		if not candamage and mobj.type == MT_MINUS
		and not (mobj.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mobj.flags = (mobj.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end

		if not candamage and mobj.type == MT_EGGGUARD and mobj.tracer //nuke Egg Guard's shield!
			P_KillMobj(mobj.tracer, mo, mo, 0)
			return
		end
		
		if mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
			P_KillMobj(mobj, mo, mo, 0) //just murder spikes!
			return
		end
		
		if mobj.type == MT_SALOONDOOR
			mobj.flags = $ | MF_SHOOTABLE | MF_ENEMY
		end
		
		//Uppercut wind!
		if wind
			if CBW_Battle and not player.mo.bpatchsupercaceepunch then
				local guh = R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)
				if (guh - getinputangle(player, true) > coneradius)
				or (guh - getinputangle(player, true) < -1*coneradius)
				or mobj.caceeupdrafted
				then
					return
				end
			end
			if player.caceeuppermomz
				mobj.momz = player.caceeuppermomz*2
			else
				mobj.momz = mo.momz
			end
			if CBW_Battle and mobj.player then mobj.caceeupdrafted = true end
			if mobj.type == MT_CACEE_POT then mobj.momz = $*11/10 end
			
			//Do player things
			if mobj.player
				if P_IsObjectOnGround(mobj)
					local oldflags = mobj.player.pflags
					mobj.z = $+P_MobjFlip(mobj)
					P_ResetPlayer(mobj.player)
					mobj.player.pflags = $|PF_JUMPED&~PF_THOKKED
					if oldflags & PF_SPINNING
					or (oldflags & PF_JUMPED and not (oldflags & PF_NOJUMPDAMAGE))
						mobj.state = S_PLAY_ROLL
					else
						mobj.state = S_PLAY_FALL
						mobj.player.pflags = $ | PF_NOJUMPDAMAGE
					end
					
				//Look, I know this is a hack and may cause issues, but I don't care!
				elseif P_PlayerInPain(mobj.player) and not mobj.player.secondjump
					mobj.player.secondjump = -1
				end
			end
			
		//Springing (Annoyingly complicated...)
		elseif mobj.flags & MF_SPRING
			//Slam jam
			if player.caceepunch == 3
				DoSlam(player, true)
			end
			
			//Prepare reset
			local oldability = player.charability
			local oldpanim = player.panim
			local oldstate = mo.state
			
			//Force power spring
			player.charability = CA_TWINSPIN
			player.panim = PA_ABILITY
			
			//Do it!
			P_DoSpring(mobj, mo)
			dosprong(player)
			
			//Reset
			player.charability = oldability
			if mo.state == oldstate
				player.panim = oldpanim
			else
				player.caceepunch = 0
			end
			
			//Spin when hitting a horizontal spring
			if not mobj.info.mass and mobj.info.damage
				P_ResetPlayer(player)
				S_StartSound(mo, sfx_spin)
				
				player.pflags = $ | PF_SPINNING
				mo.state = S_PLAY_ROLL
			end
			
		//That's right, we're doing this the hard way.
		elseif mobj.type == MT_METALSONIC_BATTLE and mobj.state == S_METALSONIC_FLOAT
			mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh),
			FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS)))
			if (P_RandomChance(FRACUNIT/2)) then mobj.movedir = InvAngle(mobj.movedir) end
			mobj.threshold = 6 + (FixedMul(24<<FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS))>>FRACBITS)
			if (mobj.info.activesound) then S_StartSound(mobj, mobj.info.activesound) end
			if (mobj.info.painchance) then mobj.state = mobj.info.painchance end
			mobj.flags2 = $ & ~MF2_INVERTAIMABLE
			
		elseif candamage and mobj.player and CBW_Battle and CBW_Battle.BattleGametype()
			CBW_Battle.PlayerTouch(mo,mobj)
			
		elseif candamage and mobj.battleobject and CBW_Battle
			CBW_Battle.BashableCollision(mobj, mo)
			
		//Unlike the orignal script this always deals one damage, no matter what
		else
			if mobj.player and mobj.player.guard == -1
				mobj.player.guard = 0
				mobj.player.guardtics = 0
			end
			if not candamage and mobj.player
				P_DamageMobj(mobj, thokmobj, mo, 1, 0)
			else
				P_DamageMobj(mobj, mo, mo, 1, 0)
			end
		end
		
		if mobj and mobj.valid and mobj.type == MT_SALOONDOOR
			mobj.flags = mobj.info.flags
		end
	end, thokmobj)
	
	return player.caceepunch
end

//What it says on the tin
local breakfloor = function(mo)
	if mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid
		for fof in mo.subsector.sector.ffloors()
			if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
			if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
			
			local extra = (mo.state == S_PLAY_TWINSPIN and mo.momz or 0)
			
			if mo.z + extra + mo.height < fof.bottomheight continue end -- Are we too low?
			if mo.z + extra > fof.topheight continue end -- Are we too high?  
			
			EV_CrumbleChain(fof) -- Crumble
		end
	end
end

//You're an idiot for touching a cactus
local hugpain = function(player, inflictor)
	local ang = player.drawangle
	local fallbackspeed = FixedMul(4*FRACUNIT, player.mo.scale)

	P_ResetPlayer(player)
	player.pflags = $|PF_THOKKED
	player.mo.silv_floatstate = 0
	player.mo.state = S_PLAY_STUN
	if (player.mo.eflags & MFE_VERTICALFLIP)
		player.mo.z = $-1
	else
		player.mo.z = $+1
	end

	if (player.mo.eflags & MFE_UNDERWATER)
		P_SetObjectMomZ(player.mo, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
	else
		P_SetObjectMomZ(player.mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
	end

	if inflictor and inflictor.valid
		ang = R_PointToAngle2(inflictor.x-inflictor.momx, inflictor.y - inflictor.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
		fallbackspeed = FixedMul(4*FRACUNIT, inflictor.scale) // the usual amount of force
	elseif player.mo.momx or player.mo.momy
		ang = R_PointToAngle2(player.mo.momx, player.mo.momy, 0, 0)
	end

	player.drawangle = ang + ANGLE_180
	P_InstaThrust(player.mo, ang, fallbackspeed)
	S_StartSound(player.mo, sfx_spkdth)
end

//Reset deez
local resetcacee = function(player)
	player.caceespike = 0
	if player.caceepunch and player.realmo and player.realmo.valid
		player.camerascale = skins[player.realmo.skin].camerascale
	end
	player.caceepunch = 0
	player.caceethrust = 0
	player.caceeupperspeed = nil
	player.caceeuppermomz = nil
	player.caceeupperangle = player.drawangle
	player.caceeuppertimer = 0
	player.caceeupperstart = false
	if player.caceeburn == nil or leveltime <= 2 or player.spectator
	or player.playerstate or player.iseggrobo or player.isjettysyn
		player.caceeburn = 0
	end
	player.caceecrisp = false
	player.caceeinputangle = player.drawangle
	player.caceemultihits = 0
end

//Initalize the variables
for player in players.iterate
	 resetcacee(player)
end

addHook("PlayerSpawn", function(player)
	resetcacee(player)
	
	//I/O maybe
	if player.caceehoming == nil and player.caceecamera == nil
		player.caceehoming = 1
		player.caceecamera = 0
		
		if io and player == consoleplayer
			local file = io.openlocal("client/Cacee.dat")
			if file
				local num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "caceehoming "..num.." 0")
				end
				local num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "caceecamera "..num.." 0")
				end
				file:close()
			end
		end
	end
end)

//Main character thinker
addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee") then return end
	local mo = player.mo

	if player.powers[pw_justsprung] or (mo.eflags & MFE_SPRUNG) then
		dosprong(player)
	end
	
	//Maybe fix cacee punching through walls
	if mapheaderinfo[gamemap].typeoflevel&TOL_ERZ3
		if mo.radius == FixedMul(skins["cacee"].radius, mo.scale)
			mo.radius = FixedMul(skins["sonic"].radius, mo.scale)
		end
		mo.shadowscale = FRACUNIT*7/8
	end
	
	//Fang showdown
	if mo.caceefang and mo.caceefang.valid
		local fang = mo.caceefang
		
		if P_PlayerInPain(player) or not mo.health
			mo.caceefang = nil
			mo.caceefangtimer = 0
			mo.reactiontime = 0
			if player.awayviewmobj and player.awayviewmobj.valid
				P_KillMobj(player.awayviewmobj)
			end
			S_ChangeMusic("VSFANG", true, player, nil, MUSICRATE*1457/250)
			return
		end
		
		if player.cmd.buttons == 0 then
			mo.caceeguntapready = true
			mo.caceeguntapping = false
		elseif mo.caceeguntapready then
			mo.caceeguntapping = true
			mo.caceeguntapready = false
		else
			mo.caceeguntapping = false
		end
		
		mo.angle = ANGLE_225
		player.drawangle = ANGLE_225
		
		if fang.state == S_FANG_INTRO9
			P_SetMobjStateNF(fang, S_FANG_IDLE1)
			S_ChangeMusic("MXSTNDF", false, player)
		end
		
		if fang.state >= S_FANG_IDLE1 and fang.state <= S_FANG_IDLE8
		and fang.tics == 1
			P_SetMobjStateNF(fang, states[fang.state].nextstate)
		end
		
		if mo.caceefangtimer
			mo.caceefangtimer = $+1
			if mo.caceefangtimer >= 8*TICRATE
				if mo.caceefangtimer == 8*TICRATE
					local dist = R_PointToDist2(mo.x, mo.y, fang.x, fang.y)/2
					local thok = P_SpawnMobjFromMobj(mo,
					P_ReturnThrustX(nil, player.drawangle, dist*2/5),
					P_ReturnThrustY(nil, player.drawangle, dist), 0, MT_THOK)
					thok.state = S_ALART1
					S_StartSound(thok, sfx_rail1)
					thok.fuse = TICRATE 
				end
				
				if mo.state == S_PLAY_CLING
				and mo.caceeguntapping
				and mo.caceefangtimer < 17*TICRATE/2
					mo.state = S_PLAY_CLIMB
					mo.tics = -1
					
					local zpos = function(posmo)
						return posmo.z + (posmo.height - mobjinfo[player.revitem].height)/2
					end
					
					local bullet = P_SpawnPointMissile(mo, fang.x, fang.y,
					zpos(fang), player.revitem, mo.x, mo.y, zpos(mo))
				end
				
				if mo.caceefangtimer == 17*TICRATE/2 and mo.state == S_PLAY_CLING
					fang.target = mo
					fang.state = S_FANG_FIRE1
					fang.extravalue2 = 1
				end
				
				if mo.caceefangtimer >= 9*TICRATE
				and player.awayviewmobj and player.awayviewmobj.valid
					P_KillMobj(player.awayviewmobj)
				end
				
				if mo.caceefangtimer >= 10*TICRATE
					mo.caceefang = nil
					mo.caceefangtimer = 0
					mo.reactiontime = 0
					mo.state = S_PLAY_STND
					
					if mapheaderinfo[gamemap].muspostbossname
						S_ChangeMusic(mapheaderinfo[gamemap].muspostbossname, true, player)
					end
					
					local gun = P_SpawnMobjFromMobj(mo,
					P_ReturnThrustX(nil,mo.angle,16*FRACUNIT),
					P_ReturnThrustY(nil,mo.angle,16*FRACUNIT),0,MT_CACEE_HAT)
					gun.skin = mo.skin
					gun.state = S_TAILSOVERLAY_0DEGREES
					gun.flags = $&~MF_NOGRAVITY
					gun.angle = mo.angle-ANGLE_45
					P_InstaThrust(gun, gun.angle, 4*gun.scale)
					P_SetObjectMomZ(gun, 4*FRACUNIT, false)
				end
			end
		else
			mo.caceefangtimer = P_RandomKey(TICRATE*2)+1
		end
		return
	elseif mo.caceefangtimer
		mo.caceefangtimer = 0
		mo.reactiontime = 0
		mo.state = S_PLAY_STND
		if player.awayviewmobj and player.awayviewmobj.valid
			P_KillMobj(player.awayviewmobj)
		end
	end
	
	//Wait speed
	if player.mo.state == S_PLAY_WAIT
		player.mo.anim_duration = min($,5)
	end
	
	//Skid animation
	if mo.state == S_PLAY_SKID
		local tics = mo.tics
		if not (tics%4)
			mo.state = S_PLAY_SKID
			mo.tics = tics
		end
	end
	
	//Burn timer
	if player.caceeburn
		if player.powers[pw_super]
			player.caceeburn = 0
		elseif mo.eflags&MFE_UNDERWATER and not (mo.eflags&MFE_TOUCHLAVA)
			player.caceeburn = 0
			S_StartSound(mo, sfx_s3k4b)
		else
			if player.caceeburn >= BURNTHRESHOLD and leveltime%4 == 0
				local smoke = P_SpawnMobjFromMobj(mo,25*(P_RandomFixed()-(FRACUNIT/2)),
				50*(P_RandomFixed()-(FRACUNIT/2)),
				(50*(P_RandomFixed()-(FRACUNIT/2)))+(mo.height/2),MT_SMOKE)
				smoke.momx = mo.momx/2
				smoke.momy = mo.momy/2
				smoke.momz = mo.momz/2
			end
			
			if not player.powers[pw_flashing]
				player.caceeburn = $-1
			end
		end
	end
	
	//Carry body damage
	if player.powers[pw_carry] and mo.tracer and mo.tracer.valid
	and (mo.tracer.flags&MF_SHOOTABLE or mo.tracer.flags&MF_ENEMY
	or mo.tracer.flags&MF_BOSS) and not mo.tracer.player
		if mo.tracer.flags&MF_ENEMY or mo.tracer.flags&MF_BOSS
			player.powers[pw_flashing] = max($,TICRATE)
		end
		P_DamageMobj(mo.tracer, mo, mo, 1, DMG_SPIKE)
		P_ResetPlayer(player)
		mo.momx = mo.caceemomx
		mo.momy = mo.caceemomy
		mo.momz = mo.caceemomz
		player.pflags = $|PF_JUMPED&~PF_STARTJUMP&~PF_THOKKED
		mo.state = S_PLAY_JUMP
	else
		mo.caceemomx = mo.momx
		mo.caceemomy = mo.momy
		mo.caceemomz = mo.momz
	end
	
	//Body damage for other players
	if (player.hugged and player.hugged.valid
	and player.hugged.mo and player.hugged.mo.valid
	and (player.hugged.hugging == player or player.hugged.hug == player)
	and player.hugged.mo.skin != "cacee"
	and player.hugged.mo.skin != "milne"
	and not (player.hugged.charflags&SF_MACHINE)
	and not player.hugged.powers[pw_flashing]
	and not player.hugged.powers[pw_invulnerability]
	and not player.hugged.powers[pw_super])
	or (player.powers[pw_carry] == CR_PLAYER and mo.tracer and mo.tracer.valid
	and mo.tracer.player and mo.tracer.skin != "cacee"
	and mo.tracer.skin != "milne" and not (mo.tracer.player.charflags&SF_MACHINE)
	and not mo.tracer.player.powers[pw_flashing]
	and not mo.tracer.player.powers[pw_invulnerability]
	and not mo.tracer.player.powers[pw_super])
		player.caceehugpain = $+1
		if player.caceehugpain >= 5
			
			if player.powers[pw_carry] == CR_PLAYER
				hugpain(mo.tracer.player, mo)
				P_ResetPlayer(player)
			else
				player.hugged.hugging = nil
				player.hugged.hug = nil
				hugpain(player.hugged, mo)
			end
			
			player.hugged = nil
			player.caceehugpain = TICRATE/2
		end
	elseif player.caceehugpain == nil
		player.caceehugpain = 0
	elseif player.caceehugpain
		player.caceehugpain = $-1
	end
	
	//Disallows the rest of the code in certain circumstances
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	//or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
	or player.powers[pw_super] == 1
	or (player.solchar and player.solchar.istransformed == 1)
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
		//Fire death
		if player.playerstate == PST_DEAD
			if player.caceecrisp
				mo.colorized = true
				mo.color = SKINCOLOR_BLACK
				S_StartSound(mo, sfx_s3k4b)
				S_StartSound(mo, sfx_s3k48)
			elseif mo.colorized and mo.color == SKINCOLOR_BLACK
				local smoke = P_SpawnMobjFromMobj(mo,25*(P_RandomFixed()-(FRACUNIT/2)),
				50*(P_RandomFixed()-(FRACUNIT/2)),
				(50*(P_RandomFixed()-(FRACUNIT/2)))+(mo.height/2),MT_SMOKE)
			end
		end
		
		resetcacee(player)
		return
	end
	
	if mo.eflags & MFE_SPRUNG
		player.caceeinputangle = player.drawangle
	elseif P_GetPlayerControlDirection(player)
		player.caceeinputangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	end
	
	//Punch
	if player.caceepunch
		local angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
		if not mo.momx and not mo.momy
			angle = getinputangle(player)
		end
		
		local thrust = player.caceethrust
		//if P_IsObjectOnGround(mo)
		//	thrust = $*9/8
		//end
		
		local camscale = skins["cacee"].camerascale
		if player.camerascale > camscale
			player.camerascale = max($*19/20, camscale)
		elseif player.camerascale < camscale
			player.camerascale = min($*21/20, camscale)
		end
		
		//Earthquake
		if player.caceepunch == 3 and (P_IsObjectOnGround(mo)
		or mo.eflags & (MFE_SPRUNG|MFE_JUSTHITFLOOR))
			DoSlam(player)
			
		//Cancel
		elseif player.panim != PA_ABILITY2 and player.panim != PA_DASH
		and mo.state != S_PLAY_GLIDE
			local oldpunch = player.caceepunch
			player.caceepunch = 0
			player.camerascale = camscale
			player.pflags = $&~PF_SHIELDABILITY
			
			if player.panim < PA_PAIN
				if P_IsObjectOnGround(mo)
					if player.speed >= FixedMul(player.runspeed, mo.scale)
						mo.state = S_PLAY_RUN
					elseif player.speed <= mo.scale
						mo.state = S_PLAY_STND
					else
						mo.state = S_PLAY_WALK
					end
				else
					mo.state = S_PLAY_FALL
				end
			elseif oldpunch == 4 and mo.state == S_PLAY_JUMP
			and not (CBW_Battle and CBW_Battle.BattleGametype())
			and player.panim == PA_JUMP and player.pflags & PF_JUMPED
			and player.pflags & PF_STARTJUMP and player.pflags & PF_NOJUMPDAMAGE
				mo.momx = player.caceejumpmomx or 0
				mo.momy = player.caceejumpmomy or 0
				
				mo.sprite2 = SPR2_MLEL
				mo.tics = 7
			end
			
		//Normal
		elseif nukepunch(player, 60*mo.scale, true)
			if player.caceepunch <= 3
				player.caceejumpmomx = mo.momx
				player.caceejumpmomy = mo.momy
			end
			
			if P_IsObjectOnGround(mo) and player.caceepunch < 3
			and ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			or (player.solchar and player.solchar.istransformed))
				//Flaming trail
				if (player.solchar and player.solchar.istransformed)
					for i = 1, 2
						local fire = P_SpawnPlayerMissile(mo, MT_SPINFIRE, 0)
						if not (fire and fire.valid) then continue end
						
						fire.state = S_LASERFLAME3 + (leveltime % 3)
						fire.tics = max($, 1)
						if mo.momx or mo.momy
							fire.angle = R_PointToAngle2(0,0, mo.momx, mo.momy)
						else
							fire.angle = player.drawangle
						end
							
						local move = i & 1 and -1 or 1
						P_TryMove(fire,
						fire.x + P_ReturnThrustX(mo, fire.angle + ANGLE_90, mo.radius*move),
						fire.y + P_ReturnThrustY(mo, fire.angle + ANGLE_90, mo.radius*move),
						false)
						
						fire.spriteyoffset = $ - 8*FRACUNIT
						fire.flags = $ &~ MF_NOGRAVITY &~ MF_FIRE
						fire.radius = 24*fire.scale
					end
					
				//Elemental fire but with a shorter fuse
				elseif CBW_Battle and CBW_Battle.BattleGametype()
					local ground = mo.floorz
					local isgravflip = P_MobjFlip(mo) < 0
					if isgravflip
						ground = mo.ceilingz - FixedMul(mobjinfo[MT_SPINFIRE].height, mo.scale)
					end

					local travelangle = R_PointToAngle2(0, 0, player.rmomx, player.rmomy)
					for i = 0, 1
						local newx = mo.x + P_ReturnThrustX(mo, (travelangle + ((i*2)-1)*ANGLE_135), FixedMul(24*FRACUNIT, mo.scale))
						local newy = mo.y + P_ReturnThrustY(mo, (travelangle + ((i*2)-1)*ANGLE_135), FixedMul(24*FRACUNIT, mo.scale))

						if (mo.standingslope)
							ground = P_GetZAt(mo.standingslope, newx, newy)
							if isgravflip
								ground = $-FixedMul(mobjinfo[MT_SPINFIRE].height, mo.scale)
							end
						end

						local flame = P_SpawnMobj(newx, newy, ground, MT_SPINFIRE)
						flame.target = mo
						flame.angle = travelangle
						flame.destscale = mo.scale
						P_SetScale(flame, mo.scale)
						if isgravflip then
							flame.flags2 = $|MF2_OBJECTFLIP
						end
						if not (gametyperules & GTR_FRIENDLY)
							flame.state = S_TEAM_SPINFIRE1
							flame.color = mo.color
						end
						
						//What we came here for
						local v10factor = (CBW_Battle.VersionNumber and CBW_Battle.VersionNumber >= 10) and 1 or 3
						flame.fuse = TICRATE/v10factor

						flame.momx = 8 -- this is a hack which is used to ensure it still behaves as a missile and can damage others
						P_XYMovement(flame)

						if not (flame and flame.valid)
							//nothing
						elseif isgravflip
							if (flame.z + flame.height < flame.ceilingz)
								P_RemoveMobj(flame)
							end
						elseif (flame.z > flame.floorz)
							P_RemoveMobj(flame)
						end
					end
					
				//Normal fire
				else
					P_ElementalFire(player)
				end
			end
			
			if mo.state == S_PLAY_MELEE_FINISH or mo.state == S_PLAY_MELEE_LANDING
			or mo.state == S_PLAY_FIRE_FINISH
				mo.tics = min($, 10)
			end
			
			player.powers[pw_noautobrake] = max($, 5)
			player.skidtime = 0
			
			if player.caceepunch < 3 and mo.state != S_PLAY_MELEE_FINISH
			and mo.state != S_PLAY_FIRE_FINISH and not player.powers[pw_pushing]
			and not player.powers[pw_justlaunched] and not player.homing
			and not mo.pushed
				//if (mo.frame&FF_FRAMEMASK) == 0
				//	P_InstaThrust(mo, angle, mo.tics*thrust/5)
				//else
					P_InstaThrust(mo, angle, thrust)
				//end
				player.drawangle = angle
				if mo.eflags&MFE_UNDERWATER
					mo.momx = $*2/3 mo.momy = $*2/3
				end
			end
			player.panim = PA_DASH
		end
		
		//No jumping
		if (CBW_Battle and CBW_Battle.BattleGametype()) and (player.caceepunch > 3
		or (mo.state != S_PLAY_MELEE_FINISH and mo.state != S_PLAY_FIRE_FINISH
		and player.caceepunch == 3 and (mo.frame&FF_FRAMEMASK) == 0))
			player.pflags = $|PF_JUMPSTASIS
		end
		
		//Ghost effect
		if player.caceepunch and player.caceepunch <= 3 and leveltime&1
			/*
			local thok = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
			thok.target = mo
			thok.state = S_INVISIBLE
			thok.tics = 2
			A_CapeChase(thok, 16*FRACUNIT, 32*FRACUNIT + 12*((player.caceepunch == 2) and 1 or -1))
			thok.momx = mo.momx
			thok.momy = mo.momy
			thok.momz = mo.momz
			P_Thrust(thok, player.drawangle, -2*mo.scale)
			caceecircle(thok, MT_THOK, 16, 4*mo.scale, 0, mo.scale/4, true, SKINCOLOR_RED, true, player.drawangle)
			*/
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = player.caceepunch >= 3 and SKINCOLOR_SUPERGOLD2
			or (G_GametypeHasTeams() and player.ctfteam == 2 and SKINCOLOR_MIDNIGHTBLUE or SKINCOLOR_CRIMSON)
			
			if player.speed < mo.scale*5
				P_InstaThrust(ghost, angle, mo.scale*-5 + player.speed)
			end
			if ghost.tracer and ghost.tracer.valid
				P_KillMobj(ghost.tracer)
			end
		end
		
		//Break walls
		if not (player.pflags&PF_DRILLING)
			player.pflags = $|PF_DRILLING
			player.charflags = $|SF_NOSPEEDADJUST
			if SF_CANBUSTWALLS
				player.charflags = $|SF_CANBUSTWALLS
			else
				player.charability = CA_GLIDEANDCLIMB
			end
		end
		
		if player.powers[pw_super] or player.powers[pw_sneakers]
			player.normalspeed = max($,thrust/2)
		else
			player.normalspeed = max($,thrust)
		end
	
	//Uppercut
	elseif mo.state == S_PLAY_TWINSPIN
		if mo.frame&FF_FRAMEMASK > 1 and player.caceeuppermomz == nil
		and (mo.momz*P_MobjFlip(mo) < -4*mo.scale or P_IsObjectOnGround(mo))
			mo.state = S_PLAY_FALL
			mo.sprite2 = SPR2_TWIN
			player.caceeuppertimer = 0
		else
			local inputangle = getinputangle(player, true)
			
			if mo.frame&FF_FRAMEMASK > 1
				//No ending the animation!
				mo.tics = -1
				local upperradius = 300*mo.scale
				--if CBW_Battle then upperradius = $*2/3 end
				
				//Undo the momentum cancel
				if player.caceeupperspeed != nil and player.caceeuppermomz != nil
					mo.momz = player.caceeuppermomz*2
					mo.z = $ + P_MobjFlip(mo)
					P_InstaThrust(mo, inputangle,
					max(player.caceeupperspeed/2, player.caceeupperspeed-18*mo.scale))
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE|PF_STARTJUMP
					player.caceeupperstart = true
					
					nukepunch(player, upperradius, true, true) //Wind stuff
					
					player.caceeupperspeed = nil
					player.caceeuppermomz = nil
				end
				
				if player.caceeupperstart and not (player.pflags&PF_STARTJUMP)
					player.caceeupperstart = false
					nukepunch(player, upperradius, true, true) //Wind stuff
				end
				
				//Spinning (yoinked from Kart)
				local speed = max(1, min(8, mo.momz*P_MobjFlip(mo)/2/mo.scale))
				local angle = inputangle - player.caceeupperangle
				if angle > abs(ANGLE_180)
					angle = $+ANGLE_180*2
				elseif angle < ANGLE_180
					angle = $-ANGLE_180*2
				end
				if speed == 1 and abs(angle) < ANGLE_22h
					player.caceeupperangle = inputangle // Face forward at the end of the animation
				else
					player.caceeupperangle = $+(ANGLE_11hh * speed)
				end
				player.drawangle = player.caceeupperangle
				
				//Keep Simple from spazzing out
				if P_GetPlayerControlDirection(player) == 0
				and player.pflags&PF_DIRECTIONCHAR and player.pflags&PF_ANALOGMODE
					player.mo.angle = player.cmd.angleturn<<16
				end
				
				//Afterimage
				if mo.momz*P_MobjFlip(mo) > 0 and leveltime&1
					local ghost = P_SpawnGhostMobj(mo)
					ghost.colorized = true
					ghost.color = (G_GametypeHasTeams() and player.ctfteam == 2) and SKINCOLOR_SKY or SKINCOLOR_ROSY
					if ghost.tracer and ghost.tracer.valid
						P_KillMobj(ghost.tracer)
					end
					
					breakfloor(mo)
				end
				
				//Extended hitbox
				nukepunch(player, 60*mo.scale, true)
			else
				player.pflags = $|PF_JUMPSTASIS
			end
			
			//Break walls
			if not (player.pflags&PF_DRILLING)
				player.pflags = $|PF_DRILLING
				player.charflags = $|SF_NOSPEEDADJUST
				if SF_CANBUSTWALLS
					player.charflags = $|SF_CANBUSTWALLS
				else
					player.charability = CA_GLIDEANDCLIMB
				end
			end
			
			if player.caceeuppertimer
				player.caceeuppertimer = $-1
			end
			//player.normalspeed = skins["cacee"].normalspeed/2
			player.panim = PA_DASH
		end
		
	//Stop breaking walls dummy
	elseif player.pflags&PF_DRILLING
		player.pflags = $&~PF_DRILLING
		player.charflags = $&~SF_NOSKID&~SF_NOSPEEDADJUST
		if SF_CANBUSTWALLS
			player.charflags = $&~SF_CANBUSTWALLS
		else
			player.charability = skins["cacee"].ability
		end
		
		player.caceeuppertimer = 0
		player.normalspeed = skins["cacee"].normalspeed
	end
	
	//Spike walk
	if player.caceespike
		if P_IsObjectOnGround(mo) and player.skidtime
		or (mo.state == S_PLAY_WALK or mo.state == S_PLAY_RUN)
		and mo.tics == 1 and (mo.frame&FF_FRAMEMASK == 3
		or mo.frame&FF_FRAMEMASK == (mo.state == S_PLAY_RUN and 1 or 7))
			S_StartSound(mo, sfx_s236)
			S_StopSoundByID(mo, sfx_skid)
		end
		player.caceespike = $-1
	end
end)

//Uppercut
addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee"
	and (player.charability == CA_DOUBLEJUMP or player.charability == CA_GLIDEANDCLIMB or srb2p)
	and not player.gotflag and not player.gotcrystal) then return end
	local mo = player.mo
	
	if not (player.pflags&PF_THOKKED) or player.charflags&SF_MULTIABILITY
		player.pflags = $&~PF_JUMPED
		P_DoJump(player, false)
		player.caceeupperspeed = FixedHypot(mo.momx, mo.momy)
		player.caceeuppermomz = CBW_Battle and mo.momz*3/4 or mo.momz
		player.caceeupperangle = player.drawangle
		player.caceeuppertimer = UPPERTIME
		player.caceemultihits = 0
		
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		
		if player.caceepunch
			player.caceepunch = 0
			player.camerascale = skins["cacee"].camerascale
		end
		player.pflags = $|PF_THOKKED|PF_FULLSTASIS|PF_DRILLING&~PF_STARTJUMP&~PF_SPINNING
		player.charflags = $|SF_NOSPEEDADJUST
		if SF_CANBUSTWALLS
			player.charflags = $|SF_CANBUSTWALLS
		else
			player.charability = CA_GLIDEANDCLIMB
		end
		
		S_StartSound(mo, sfx_ceuppr)
		if P_RandomChance(FRACUNIT/70) then S_StartSound(mo, sfx_ceshok) end
		if player.solchar and player.solchar.istransformed
			S_StartSound(mo, sfx_s3k48)
		end
		
		if CBW_Battle then
			caceecircle(mo, MT_DUST, 16, 16*mo.scale, 0, mo.scale, false, 0, false, player.drawangle, 16*36/5)
		else
			caceecircle(mo, MT_DUST, 16, 16*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
		end
		mo.state = S_PLAY_STND
		mo.state = S_PLAY_TWINSPIN
		player.panim = PA_DASH
		//mo.tics = $*2
	end
	return true
end)

//Punch
local function DoPunch(player, forcedtype)
	local mo = player.mo
	local angle = getinputangle(player)
	local lockon = P_LookForEnemies(player, false, false)
	local lockonvalid = lockon and lockon.valid
	local speed = FixedHypot(mo.momx, mo.momy)
	local slammed = player.caceepunch == 4
	
	player.drawangle = angle
	player.caceeuppertimer = 0
	
	if forcedtype
		player.caceepunch = forcedtype
	elseif player.caceepunch <= 0 or player.caceepunch >= 3
		player.caceepunch = 1
	else
		player.caceepunch = $+1
	end
	S_StartSound(mo, sfx_cepun1+player.caceepunch-1)
	
	if (CBW_Battle and player.caceepunch == 1)
		player.caceethrust = max(20*mo.scale, speed)
	elseif player.gotflagdebuff
		player.caceethrust = speed
	elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and lockonvalid
	and not P_IsObjectOnGround(mo) and not forcedtype
	and not player.gotflag and not player.gotcrystal
		player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
		mo.target = lockon
		mo.tracer = lockon
		mo.angle = R_PointToAngle2(mo.x, mo.y, lockon.x, lockon.y)
		S_StartSound(mo, sfx_s3k40)
		player.homing = 3*TICRATE
	elseif abs(player.cmd.forwardmove) <= 25 and abs(player.cmd.sidemove) <= 25
		player.caceethrust = min(max(10*mo.scale,speed),40*mo.scale)
	else
		local oldthrust = player.caceethrust
		
		if P_IsObjectOnGround(mo)
			player.caceethrust = max(34*mo.scale + 6*player.caceepunch*mo.scale, speed)
		else
			player.caceethrust = max(37*mo.scale, speed) + 3*mo.scale
		end
		
		if slammed then player.caceethrust = max($, oldthrust) end
		
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
		or player.solchar and player.solchar.istransformed
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
				player.pflags = $|PF_SHIELDABILITY
			end
			player.caceethrust = $ + 6*mo.scale
			S_StartSound(mo, sfx_s3k43)
		end
		
		if lockonvalid and player.caceehoming
		and not (CBW_Battle and lockon.type == MT_TARGETDUMMY)
		and abs((mo.z+mo.height/2)-(lockon.z+lockon.height/2)) <= mo.height*(P_IsObjectOnGround(mo) and 1 or 2)
			angle = R_PointToAngle2(mo.x,mo.y,lockon.x,lockon.y)
			
			if player.caceecamera
				mo.angle = angle
			end
			
			if not P_IsObjectOnGround(mo)
				local z = mo.z + mo.height/2
				if (mo.eflags & MFE_VERTICALFLIP) then z = $-FixedMul(mo.height, mo.scale) end
				mo.momz = (lockon.z + lockon.momz - z) / max((P_AproxDistance(lockon.x + lockon.momx - mo.x, lockon.y + lockon.momy - mo.y)/max(player.caceethrust,1)),1)
				mo.momz = max(min($, mo.scale*16), mo.scale*-16)
			end
		end
	end
	
	if player.powers[pw_pushing]
		player.caceethrust = $/2
	end
	if CBW_Battle and CBW_Battle.BattleGametype()
		player.caceethrust = min($, 53*mo.scale) //Ugh, Battle nerfs.
	end
	
	if player.caceethrust and not player.gotflagdebuff
		P_InstaThrust(mo, angle, player.caceethrust)
	end
	if mo.eflags&MFE_UNDERWATER
		mo.momx = $*2/3 mo.momy = $*2/3
	end
	
	if not P_IsObjectOnGround(mo) and mo.momz*P_MobjFlip(mo) < 0
		mo.momz = $/2
	end
	
	local one = 3
	local two = 4
	if player.caceethrust < 40*mo.scale
		one = 6
		two = 7
	end
	
	if abs(player.cmd.angleturn<<16 - angle) > ANGLE_90
		player.camerascale = skins["cacee"].camerascale*one/two
	else
		player.camerascale = skins["cacee"].camerascale*two/one
	end
	
	player.powers[pw_noautobrake] = max($, 5)
	player.skidtime = 0
	player.charflags = $|SF_NOSKID|SF_NOSPEEDADJUST
	player.pflags = $|PF_FULLSTASIS|PF_DRILLING&~PF_SPINNING
	if SF_CANBUSTWALLS
		player.charflags = $|SF_CANBUSTWALLS
	else
		player.charability = CA_GLIDEANDCLIMB
	end
	
	mo.state = S_PLAY_STND
	mo.state = S_PLAY_MELEE
	mo.tics = $+1
	
	if player.caceepunch >= 3
		if P_IsObjectOnGround(mo)
			player.pflags = $|PF_JUMPED
		end
		
		mo.z = $+P_MobjFlip(mo)
		mo.momz = abs(P_GetMobjGravity(mo)*8)*P_MobjFlip(mo)
		mo.eflags = $&~MFE_JUSTHITFLOOR
		mo.state = S_PLAY_GLIDE
		caceecircle(mo, MT_DUST, 16, 8*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
		
		if CBW_Battle and CBW_Battle.BattleGametype()
			//nothing
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			player.pflags = $|PF_SHIELDABILITY
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			S_StartSound(mo, sfx_s3k43)
			player.pflags = $|PF_SHIELDABILITY
		end
	elseif player.caceepunch == 2
		mo.state = S_PLAY_FIRE
		mo.tics = $+1
	end
	
	player.panim = PA_DASH
end

function DoSlam(player, spring)
	local mo = player.mo
	local angle = getinputangle(player)
	local camscale = skins["cacee"].camerascale
	
	if spring
		//nothing!
	elseif abs(player.cmd.angleturn<<16 - angle) > ANGLE_90
		player.camerascale = camscale*4/3
	else
		player.camerascale = camscale*3/4
	end
	
	if player == displayplayer
		P_StartQuake(16*FRACUNIT, 5)
	end
	
	player.caceepunch = $+1
	S_StartSound(mo, sfx_cepun4)
	if player.panim == PA_ABILITY2 or player.panim == PA_DASH
	or mo.state == S_PLAY_GLIDE
		mo.state = S_PLAY_MELEE_LANDING
		player.panim = PA_DASH
	elseif player.panim == PA_JUMP and mo.state == S_PLAY_JUMP
		mo.sprite2 = SPR2_MLEL
		mo.tics = 7
	end
	
	if not (mo.eflags & MFE_SPRUNG) and not spring and P_IsObjectOnGround(mo)
		mo.momx = 0 mo.momy = 0
	end
	
	local pounditem = MT_SUPERSPARK
	if player.powers[pw_shield] & SH_PROTECTFIRE
	or (player.solchar and player.solchar.istransformed)
		S_StartSound(mo, sfx_fire)
		pounditem = MT_FIREBALLTRAIL
		
		if player.solchar and player.solchar.istransformed
			P_ElementalFire(player, true)
			
			local thok = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
			thok.target = mo
			thok.state = S_CACEE_ERUPT
			S_StartSound(mo, sfx_cefire)
		end
	elseif player.powers[pw_shield] & SH_PROTECTWATER
		local i=0 while i<4 S_StartSound(mo, sfx_bubbl1+i) i=$+1 end
		pounditem = MT_UWEXPLODE
	elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
		player.pflags = $|PF_SHIELDABILITY
		player.homing = 2
		mo.target = nil
		S_StartSound(mo, sfx_s3ka6)
	elseif player.powers[pw_shield] & SH_PROTECTELECTRIC
		S_StartSound(mo, sfx_s3k45)
	elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
		S_StartSound(mo, sfx_wdjump)
		pounditem = MT_TNTDUST
	elseif player.powers[pw_shield] & SH_FORCE
		S_StartSound(mo, sfx_ngskid)
		player.pflags = $|PF_SHIELDABILITY
	end
	
	caceecircle(mo, pounditem, 16, 32*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
	caceecircle(mo, MT_MINECARTSPARK, 8, 8*mo.scale, 0, mo.scale/4, false, 0, false, player.drawangle)
	
	local thok = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
	thok.state = S_CACEE_HIT1
	thok.flags2 = $|MF2_SPLAT
	thok.scale = $*2
	thok.blendmode = AST_ADD
	if P_MobjFlip(mo) < 0
		thok.height = mo.scale
		thok.z = mo.z + mo.height
	end
	thok.z = $ + P_MobjFlip(mo)*mo.scale
	
	local ghost = P_SpawnGhostMobj(mo)
	ghost.colorized = true
	ghost.color = SKINCOLOR_SUPERGOLD2
	ghost.destscale = $*16
	if ghost.tracer and ghost.tracer.valid
		P_KillMobj(ghost.tracer)
	end
	
	nukepunch(player, FixedMul(RING_DIST*2/3, mo.scale))
	breakfloor(mo)
end

addHook("SpinSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee") then return end
	local mo = player.mo
	
	//No pressing spin during uppercut startup
	if mo.state == S_PLAY_TWINSPIN and mo.frame&FF_FRAMEMASK <= 1
		return true
	end
	
	if P_PlayerInPain(player)
	or srb2p
	or (player.pflags & PF_SLIDING)
	or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
	or player.powers[pw_super] == 1
	or (player.solchar and player.solchar.istransformed == 1)
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and (mo.state == S_PLAY_FACEPLANT
	or mo.state == S_PLAY_TRICKUP or mo.state == S_PLAY_TRICKDOWN))
	or P_SuperReady(player)
	or player.pflags&PF_SPINDOWN
	//or not P_IsObjectOnGround(mo)
	or mo.state == S_PLAY_MELEE or mo.state == S_PLAY_FIRE
	or ((mo.state == S_PLAY_MELEE_FINISH or mo.state == S_PLAY_FIRE_FINISH) and mo.tics >= 8)
	or player.caceepunch == 3
	or (player.caceepunch == 4 and CBW_Battle and CBW_Battle.BattleGametype())
		return
	end
	
	DoPunch(player)
end)

//No Shields
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
		return true
	end
end)

//Allow double jumps out of the Flame Shield
addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
	//and (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
	and player.pflags&PF_SHIELDABILITY and player.pflags&PF_JUMPED
	and not (player.pflags&(PF_THOKKED|PF_JUMPDOWN))
		player.pflags = $&~PF_SHIELDABILITY
	end
end)

//Punch Damage
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
		local mo = player.mo
		if mo.state == S_PLAY_TWINSPIN or player.caceepunch >= 3
			return true
		elseif player.caceepunch
			local angle = player.drawangle - R_PointToAngle2(mo.x-mo.momx,
			mo.y-mo.momy, mobj.x, mobj.y)
			if angle > abs(ANGLE_180)
				angle = $+ANGLE_180*2
			elseif angle < ANGLE_180
				angle = $-ANGLE_180*2
			end
			if abs(angle) < ANGLE_90
				return true
			end
		end
	end
end)

//Destroy spikes via attacks
local waterspike = function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
	and tmthing.player and tmthing.skin == "cacee"
	and ((tmthing.player.caceepunch and tmthing.player.caceepunch <= 2)
	or tmthing.state == S_PLAY_TWINSPIN)
	and thing.z - thing.scale <= tmthing.z + tmthing.height + (tmthing.player.caceepunch and P_MobjFlip(tmthing) or tmthing.momz)
	and thing.z + thing.height + thing.scale >= tmthing.z + (tmthing.player.caceepunch and P_MobjFlip(tmthing) or tmthing.momz)
		P_KillMobj(thing, tmthing)
		return true
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)

//Well isn't this interesting?
addHook("MobjLineCollide", function(mo, line)
	if mapheaderinfo[gamemap].lvlttl == "Arid Canyon"
	and mapheaderinfo[gamemap].actnum == 2
	and mo and mo.valid and mo.player and gamemap == 14
	and line and line.valid and (#line == 7444 or #line == 7318 or #line == 7282)
		local player = mo.player
		if line.frontside.midtexture == 0
		and line.backside.midtexture == 0
			return false
		elseif mo.skin == "cacee" and player.caceepunch
		and line.frontside.midtexture == R_CheckTextureNumForName("ACMINES5")
		and line.backside.midtexture == line.frontside.midtexture
			line.frontside.midtexture = 0
			line.backside.midtexture = 0
			if #line == 7318 and lines[7282] and lines[7282].valid
				lines[7282].frontside.midtexture = 0
				lines[7282].backside.midtexture = 0
			elseif #line == 7282 and lines[7318] and lines[7318].valid
				lines[7318].frontside.midtexture = 0
				lines[7318].backside.midtexture = 0
			end
			caceecircle(mo, MT_WOODDEBRIS, 16, 8*mo.scale, player.height/2, mo.scale, false, 0, true, player.drawangle)
			S_StartSound(mo, sfx_wbreak)
			return false
		end
	end
end, MT_PLAYER)

//Body damage
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if not (dmgtype&DMG_DEATHMASK) and dmgtype != DMG_NUKE
	and mo and mo.valid and mo.skin == "cacee" and mo.player
	and not (mo.player.solchar and mo.player.solchar.istransformed)
	and inf and inf.valid and not (inf.flags&MF_MISSILE)
	and not (inf.flags&MF_NOCLIPTHING) and inf.flags&MF_SHOOTABLE
	and not inf.player
	and R_PointToDist2(mo.x,mo.y,inf.x,inf.y) <= (mo.radius+inf.radius)*2
	and abs((mo.z+mo.height/2)-(inf.z+inf.height/2)) <= mo.height+inf.height
		resetcacee(mo.player)
		P_DamageMobj(inf, mo, mo, 1, DMG_SPIKE)
	end
end, MT_PLAYER)

local function cantakedmg(player)
	if player.powers[pw_super]
	or player.powers[pw_flashing]
	or player.powers[pw_invulnerability]
	or player.shielding
	or (player.guartics and player.guardtics > 0)
	then
		return false
	else
		return true
	end
end

//Fire Resist
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if (dmgtype == DMG_FIRE or (inf and inf.valid and inf.flags&MF_FIRE))
	and mo and mo.valid and mo.skin == "cacee" and mo.player and cantakedmg(mo.player)
	and not (mo.player.solchar and mo.player.solchar.istransformed)
	and mo.player.powers[pw_carry] != CR_NIGHTSMODE
	and not (mo.eflags&MFE_UNDERWATER and not (mo.eflags&MFE_TOUCHLAVA))
		local burn = mo.player.caceeburn
		mo.player.caceeburn = min($+BURNINCREASE, NUMTRANSMAPS*BURNFACTOR)
		mo.player.caceecrisp = true
		if burn < BURNTHRESHOLD
			P_PlayerFlagBurst(mo.player)
			P_DoPlayerPain(mo.player, inf, src)
			mo.sprite2 = SPR2_STUN
			S_StartSound(mo, sfx_shldls)
			return true
		end
	end
end, MT_PLAYER)

//Extra enemy health
addHook("MobjDamage", function(mobj, inf, src, dmg, dmgtype)
	if mobj and mobj.valid and not mobj.player and dmgtype != DMG_NUKE
	and mobj.health and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS)
		//No attacking this enemy when it's flashing
		if mobj.caceeflash and mobj.caceeflash.valid and mobj.caceeflash.fuse > TICRATE/2-7
			if inf and inf.valid and inf.player
				if inf.skin == "cacee" and inf.state == S_PLAY_TWINSPIN
				and inf.player.caceeuppertimer and not (mobj.flags&MF_BOSS
				and mobj.flags&MF_NOGRAVITY and mobj.type != MT_EGGMOBILE
				and mobj.type != MT_METALSONIC_BATTLE)
				and mobj.type != MT_BLACKEGGMAN and mobj.type != MT_CYBRAKDEMON
				and not (mapheaderinfo[gamemap].caceetutorial
				and caceetutinv[mobj.type] and mobj.flags&MF_NOGRAVITY)
					local flags = mobj.flags
					mobj.flags = $|MF_NOCLIPTHING&~MF_ENEMY&~MF_BOSS
					
					P_TryMove(mobj, mobj.x+inf.momx, mobj.y+inf.momy, true)
					mobj.z = inf.z+inf.momz+mobj.height/2
					
					mobj.flags = flags
				elseif mobj.info.spawnhealth > 1
					local angle = R_PointToAngle2(mobj.x,mobj.y,inf.x-inf.momx,inf.y-inf.momy)
					if inf.skin == "cacee" and inf.player.caceepunch
						P_InstaThrust(inf, angle, 20*inf.scale)
					else
						P_InstaThrust(inf, angle, inf.player.speed)
					end
				end
			end
			return true
		end
		
		//Skin and ability checks
		if inf and inf.valid and inf.player and inf.skin == "cacee"
			if not inf.player.caceepunch and dmgtype != DMG_SPIKE
			and inf.state != S_PLAY_TWINSPIN
				return
			end
		elseif not (src and src.valid and src.player and src.skin == "cacee"
		and inf and inf.valid and (inf.type == src.player.revitem or inf.type == MT_THOK))
			return
		elseif src.caceefang == mobj
			P_LinedefExecute(65531)
			P_KillMobj(mobj)
		end
		
		local strongpunch = false
		if inf and inf.valid and inf.player and inf.skin == "cacee"
			if inf.player.caceepunch >= 4
				strongpunch = true
				mobj.caceepain = 99
			else
				if inf.player.powers[pw_super]
				or (inf.player.solchar and inf.player.solchar.istransformed)
					strongpunch = true
					mobj.caceepain = 99
				end
				punchknockback(inf.player, mobj)
			end
		end
		
		local thok = P_SpawnMobjFromMobj(mobj,0,0,mobj.info.height/2,MT_THOK)
		if inf and inf.valid and not (inf.player and inf.skin == "cacee"
		and inf.player.caceepunch >= 4)
			P_SafeTeleportMove(thok, thok.x + (inf.x - mobj.x)/2,
			thok.y + (inf.y - mobj.y)/2,
			thok.z + ((inf.z + inf.height/2) - (mobj.z + mobj.height/2))/2)
		end
		thok.state = S_CACEE_HIT1
		thok.spritexscale = FRACUNIT/3
		thok.spriteyscale = FRACUNIT/3
		thok.blendmode = AST_ADD
		caceecircle(thok, MT_MINECARTSPARK, 3, 4*mobj.scale, 0, mobj.scale/4, false, 0, true, mobj.angle)
		
		local solexplode = false
		if inf and inf.valid and inf.player and inf.skin == "cacee"
		and (inf.player.solchar and inf.player.solchar.istransformed)
			thok = P_SpawnMobjFromMobj(mobj,0,0,0,MT_THOK)
			thok.state = S_CACEE_HIT4
			thok.fuse = thok.tics
			thok.spritexscale = FRACUNIT*2
			
			if inf.player == displayplayer
				P_StartQuake(16*FRACUNIT, 5)
			end
			S_StartSound(thok, sfx_bgxpld)
			
			solexplode = true
		end
		
		local damagesound = (dmgtype == DMG_SPIKE and sfx_cehit2)
		or (strongpunch and sfx_cehit3) or sfx_cehit1
		
		if mobj.caceepain == nil mobj.caceepain = 0 end
		local COMBOWINDOW = TICRATE
		if inf.player then inf.player.bpatchcaceepunch = -COMBOWINDOW end
		
		if (mobj.caceepain+1 >= (caceehealth[mobj.type]
		or (mobj.flags&MF_BOSS and 1) or 2) or mobj.info.spawnhealth == 0)
		and not (mapheaderinfo[gamemap].caceetutorial and caceetutinv[mobj.type])
			mobj.caceepain = 0
			if mobj.health <= 1 and mobj.flags&MF_ENEMY
				if mobj.caceeflash and mobj.caceeflash.valid
					P_KillMobj(mobj.caceeflash)
					mobj.caceeflash = nil
					mobj.flags = $&~MF_NOTHINK
				end
				local explode = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_EXPLODE)
				P_SetMobjStateNF(explode, mobj.state)
				explode.tics = -1
				explode.colorized = mobj.colorized
				explode.color = mobj.color
				explode.angle = mobj.angle
				explode.originscale = mobj.scale
				explode.destscale = mobj.scale*16
				explode.scalespeed = mobj.scale/8
				explode.fuse = TICRATE/4
				explode.target = src or inf
				if inf and inf.valid and inf.player and inf.skin == "cacee"
					if inf.player.caceeuppertimer
						explode.momx = inf.momx
						explode.momy = inf.momy
						explode.momz = inf.momz
					end
					if strongpunch
						P_SetObjectMomZ(explode, 12*FRACUNIT, true)
						P_Thrust(explode, R_PointToAngle2(inf.x, inf.y, mobj.x, mobj.y), 48*mobj.scale)
						if solexplode
							explode.momz = $*2
							explode.momx = $/2
							explode.momy = $/2
						end
						explode.scalespeed = $/2
						explode.fuse = $*2
						explode.flags = MF_NOBLOCKMAP|MF_MISSILE
						explode.cusval = (leveltime & 1) or -1
					end
				end
				
				if mobj.type == MT_SALOONDOOR
				and mobj.tracer and mobj.tracer.type == MT_SALOONDOORCENTER
					mobj.tracer.flags = $ &~ MF_SOLID
				end
				
				S_StartSound(explode,damagesound)
				P_KillMobj(mobj, inf, src)
				
				if mobj and mobj.valid
					S_StopSoundByID(mobj, mobj.info.deathsound)
					mobj.flags2 = MF2_DONTDRAW
					mobj.tics = 2
				end
				return true
			else
				S_StartSound(mobj,damagesound)
			end
		else
			if not mobj.caceepain
				mobj.caceepain = 1
			else
				mobj.caceepain = $+1
			end
			S_StartSound(mobj,damagesound)
			
			mobj.caceeflash = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_FLASH)
			mobj.caceeflash.target = mobj
			mobj.caceeflash.fuse = TICRATE/2
			if mobj.type == MT_PTERABYTE
				mobj.target = nil
			end
			if mobj.tics > 0
				mobj.tics = max($, TICRATE/2)
			end
			if mobj.info.painstate and states[mobj.info.painstate]
				mobj.sprite = states[mobj.info.painstate].sprite
				mobj.frame = states[mobj.info.painstate].frame
			end
			mobj.flags = $|MF_NOTHINK
			return true
		end
	end
end)

//An object damaging while they're flashing? No way!
addHook("ShouldDamage", function(mobj, inf)
	if inf and inf.valid and inf.caceeflash and inf.caceeflash.valid
		return false
	end
end)

//The funny
addHook("MobjMoveCollide", function(mobj, mo)
	if mobj and mobj.valid and mo and mo.valid and mo.skin == "cacee"
	and mo.player and not (mobj.caceeflash and mobj.caceeflash.valid and mobj.caceeflash.fuse > TICRATE/2-7)
	and mobj.z - mobj.scale <= mo.z + mo.height
	and mobj.z + mobj.height + mobj.scale >= mo.z
	and R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y) <= mo.radius*3
		local angle = R_PointToAngle2(mobj.x,mobj.y,mo.x-mo.momx,mo.y-mo.momy)
		if mo.player.caceepunch
			punchknockback(mo.player, mobj)
		
			S_StartSound(mobj,sfx_cehit1)
			local thok = P_SpawnMobjFromMobj(mobj,0,0,mobj.info.height/2,MT_THOK)
			if mo.player.caceepunch < 4
				P_SafeTeleportMove(thok, thok.x + (mo.x - mobj.x)/2,
				thok.y + (mo.y - mobj.y)/2,
				thok.z + ((mo.z + mo.height/2) - (mobj.z + mobj.height/2))/2)
			end
			thok.state = S_CACEE_HIT1
			thok.spritexscale = FRACUNIT/3
			thok.spriteyscale = FRACUNIT/3
			thok.blendmode = AST_ADD
			caceecircle(thok, MT_MINECARTSPARK, 3, 4*mobj.scale, 0, mobj.scale/4, false, 0, true, mobj.angle)
			
			mobj.caceeflash = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_FLASH)
			mobj.caceeflash.target = mobj
			mobj.caceeflash.fuse = TICRATE/2
			mobj.flags = $|MF_NOTHINK
			
			mobj.state = S_ROSY_PAIN
			mobj.z = $-P_GetMobjGravity(mobj)
			mobj.angle = angle
			mobj.cvmem = $-TICRATE
		elseif mobj.target == mo and mobj.state != S_ROSY_PAIN
			mobj.state = S_ROSY_PAIN
			S_StartSound(mobj, sfx_cdpcm7)
			S_StartSound(mobj, sfx_spkdth)
			A_DoNPCPain(mobj)
			mobj.angle = angle
			mobj.cvmem = $-TICRATE
		end
	end
end, MT_ROSY)

//Pain
addHook("MobjCollide", function(mo, mobj)
	if mobj and mobj.valid and mobj.flags & MF_SPRING and mobj.info.painchance != -1
	and mo and mo.valid and mo.player and mo.skin == "cacee" and mo.player.caceepunch
		return false
	end
end, MT_PLAYER)

//Actual pain
local DONTDESPAWN = true
local POT_IMMUNITY_TIME = TICRATE
addHook("TouchSpecial", function(pot, collide)
	local sameteam = CBW_Battle.MyTeam(pot.therealcacee, collide)
	if collide.player and collide.player.powers[pw_carry] == CR_ZOOMTUBE then
		return DONTDESPAWN
	end
	if (collide == pot.therealcacee) or not(collide.player and CBW_Battle and sameteam) then
		if collide.battleobject then
			collide.target = pot.target
		elseif collide.player and not sameteam then
			if collide.player.powers[pw_flashing]
			or (collide.pottime and leveltime - collide.pottime < POT_IMMUNITY_TIME)
			then 
				return DONTDESPAWN
			else
				collide.pottime = leveltime
			end
		end
		local guardingplayer = collide.player and collide.player.guardtics and collide.player.guardtics > 0
		local spawningpot = pot.health > (mobjinfo[MT_CACEE_POT].spawnhealth - POT_SPAWN_TIME)
		if collide.player and spawningpot and not (sameteam or guardingplayer) then
			CBW_Battle.ZLaunch(collide, 24*FRACUNIT)
			CBW_Battle.DoPlayerTumble(collide.player, TICRATE*2, 0, 8*FRACUNIT, true)
			S_StartSound(collide, sfx_bsnipe)
			P_PlayerFlagBurst(collide.player)
		elseif collide.player and collide.skin == "cacee" and not sameteam then
			P_DoPlayerPain(collide.player)
			S_StartSound(collide, sfx_spkdth)
			collide.player.state = S_PLAY_STUN
			collide.player.powers[pw_flashing] = 0
			P_PlayerFlagBurst(collide.player)
		else
			if guardingplayer and not (sameteam) then
				P_InstaThrust(pot, collide.player.drawangle, collide.scale*12)
				local cacee = pot.therealcacee
				if cacee
				and (cacee.lasthug and cacee.lasthug == pot)
				and (cacee.lasthugtime and leveltime - cacee.lasthugtime <= 1)
				then
					CBW_Battle.GuardFunc.Parry(collide, cacee, cacee, 1, DMG_SPIKE)
				end
			end
			P_DamageMobj(collide, pot, pot.therealcacee, 1, DMG_SPIKE)
		end
	end
	return DONTDESPAWN
end, MT_CACEE_POT)

//Partial Spike immunity
addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.skin == "cacee" and mo.player and cantakedmg(mo.player)
	and (dmgtype == DMG_SPIKE or (inf and inf.valid and (inf.type == MT_SPIKE or inf.type == MT_WALLSPIKE)))
	and not (inf and inf.valid and (inf.flags&MF_MISSILE or inf.flags&MF_PAIN
	or inf.flags&MF_ENEMY or inf.flags&MF_BOSS or inf.battleobject))
		if mo.player.gotflag
			P_PlayerFlagBurst(mo.player)
			P_DoPlayerPain(mo.player, inf, src)
			mo.sprite2 = SPR2_STUN
			S_StartSound(mo, sfx_shldls)
		else
			if not mo.player.caceespike and not mo.player.guard
				S_StartSound(mo, sfx_s255)
			end
			mo.player.caceespike = 2
		end
		return false
	end
end, MT_PLAYER)

--[[
local potpush = CV_RegisterVar{
	name = "potpush",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = {Off = 0, On = 1}
}
]]



addHook("MobjCollide", function(pot, collide)
	--z check
	if not(CBW_Battle and CBW_Battle.ZCollide(pot, collide)) then
		return
	end
	--fix upsidedown collision (UGH)
	if collide.valid and collide.player and(
		(collide.player.caceepunch and P_MobjFlip(pot) < 0 and P_MobjFlip(collide) < 0)
		--or (P_IsObjectOnGround(collide) and collide.player.pflags & PF_SPINNING)
	)then
		pot.pushed = collide
		collide.pushed = pot
		CBW_Battle.DoPlayerInteract(collide, pot)
		CBW_Battle.DoPlayerInteract(pot, collide)
		collide.pottime = leveltime + (POT_IMMUNITY_TIME/2)
		return
	end
	--collision with flags/springs
	local spawningpot = pot.health > (mobjinfo[MT_CACEE_POT].spawnhealth - POT_SPAWN_TIME)
	if collide.valid and not (pot.pushcooldown or spawningpot) then
		local isflag = collide.type == MT_REDFLAG or collide.type == MT_BLUEFLAG
		local sound = (collide.flags & MF_SPRING) and sfx_sprong or sfx_s3k87
		if (not isflag) and CBW_Battle.VersionNumber and CBW_Battle.VersionNumber >= 10 then
			isflag = collide.type == MT_CREDFLAG or collide.type == MT_CBLUEFLAG
		end
		if isflag or (collide.flags & MF_SPRING) then
			if not S_SoundPlaying(pot, sound) then
				S_StartSound(pot, sound)
			end
			P_InstaThrust(pot, R_PointToAngle2(pot.x,pot.y,collide.x,collide.y) + ANGLE_180, collide.scale*8)
			pot.pushcooldown = TICRATE
		end
	end
end, MT_CACEE_POT)

//Cactus love
addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.skin == "cacee" and mo.player and cantakedmg(mo.player)
	and inf and inf.valid and ((inf.type == MT_CACEE_POT) or inf.type >= MT_CACTI1 and inf.type <= MT_CACTISMALLSEG)
		if mo.player.gotflag and not (inf.type == MT_CACEE_POT)
			P_PlayerFlagBurst(mo.player)
			P_DoPlayerPain(mo.player, inf, src)
			mo.sprite2 = SPR2_STUN
			S_StartSound(mo, sfx_shldls)
		elseif P_IsObjectOnGround(mo) and mo.player.speed < 8*mo.scale
		and (mo.player.panim == PA_IDLE or mo.player.panim == PA_WALK)
			if not (leveltime&15)
				local cdlhrt = P_SpawnMobjFromMobj(mo, 0, 0, mo.player.height, MT_CDLHRT)
				cdlhrt.scale = (5*mo.scale) >> 4
				cdlhrt.fuse = (5*TICRATE) >> 1
				cdlhrt.momz = mo.scale
				cdlhrt.target = mo
				cdlhrt.extravalue1 = mo.x
				cdlhrt.extravalue2 = mo.y
			end
			mo.player.drawangle = R_PointToAngle2(mo.x,mo.y,inf.x,inf.y)
			mo.lasthug = inf
			mo.lasthugtime = leveltime
			--[[
			if inf.type == MT_CACEE_POT and potpush.value then
				P_Thrust(inf, mo.player.drawangle, mo.scale/10)
				if not (S_SoundPlaying(inf, sfx_statu1) or inf.dyingpot) then
					S_StartSound(inf, sfx_statu1)
				end
			end
			]]
			
			if mo.state == S_PLAY_STND and mo.tics > 0
				mo.tics = -1
			end
		end
		return false
	end
end, MT_PLAYER)

//Battle Mod Support
local PUNCHCOOLDOWN = 1 --frames. only counts down after punch anim is over to prevent free combos
local COMBOWINDOW = TICRATE --amount of frames cacee has to do her final punch after connecting one

local caceebattlethink = function(player)
	--battlemod cacee check
	if not (CBW_Battle
	and player.mo
	and player.mo.valid
	and player.mo.skin == "cacee")
	then
		return
	end

	--variables for preventing punch in certain cases
	local didntjump = (not (P_IsObjectOnGround(player.mo)))
	and (player.panim == PA_IDLE
	or player.panim == PA_WALK
	or player.panim == PA_RUN
	)
	local sprung = (not (player.pflags&PF_JUMPED))
	and (player.panim == PA_SPRING
	or player.panim == PA_FALL
	)
	local floored = (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and not (player.mo.state == S_PLAY_TWINSPIN)

	--reset some vars
	if floored then
		player.bpatchcaceeairpunched = false
		player.bpatchcaceeairpunches = 2
	end

	--punch timer (positive = can't punch, negative = can punch & immunity to positive punch timer)
	player.bpatchcaceepunch = $ or 0
	if player.bpatchcaceepunch > 0 then
		player.bpatchcaceepunch = $-1
	elseif player.bpatchcaceepunch < 0 then
		player.bpatchcaceepunch = $+1
	end
	if player.caceepunch and not(player.bpatchcaceepunch < 0) then
		if player.caceepunch == 1 and not P_IsObjectOnGround(player.mo) then
			player.bpatchcaceeairpunched = true
		end
		local cantfollowup = (player.caceepunch == 1 and player.bpatchcaceeairpunches == 1)
		if player.caceepunch >= 2 or cantfollowup then
			player.bpatchcaceepunch = PUNCHCOOLDOWN
			if not (P_IsObjectOnGround(player.mo) or player.panim == PA_JUMP) then
				player.bpatchcaceeairpunches = 0
			end
		end
		if player.mo.pushtics then
			player.bpatchcaceepunch = -COMBOWINDOW
		end
	end

	--deduct air punches on 1st punch whiffs
	if player.bpatchcaceeairpunches
	and player.bpatchcaceeairpunched
	and not (player.caceepunch or player.bpatchcaceepunch or player.panim == PA_JUMP)
	then
		player.bpatchcaceeairpunches = $-1
		player.bpatchcaceeairpunched = false
	end

	--upper hit also restores punch!
	if player.mo.state == S_PLAY_TWINSPIN and player.mo.pushtics then
		player.bpatchcaceepunch = $ and min(0,$) or 0
		player.bpatchcaceeairpunches = 2
	end

	--hold spin button QoL yay
	if player.caceepunch then
		player.pflags = $ &~ PF_SPINDOWN
	end

	--don't act out of landing state!
	if player.mo.state == S_PLAY_MELEE_LANDING then
		player.pflags = $|PF_JUMPDOWN
	end

	--this bug has been around since v1 huh
	if player.guard > 0 then
		player.pflags = $ &~ PF_SHIELDABILITY
	end

	if (didntjump
	or sprung
	or player.tumble
	or player.skidtime
	or player.bpatchcaceepunch > 0
	or not player.bpatchcaceeairpunches)
	and not (player.bpatchcaceepunch < 0)
	then
		player.pflags = $|PF_SPINDOWN
	end
end
addHook("PlayerThink", caceebattlethink)

local caceebattleprethink = function() --necessary, due to player inputs...
	if not CBW_Battle then
		return
	end
	for player in players.iterate do
		--don't act out of landing state!
		if player.mo and player.mo.state == S_PLAY_MELEE_LANDING then
			player.cmd.buttons = $ &~ BT_SPIN
		end
		--[[
		--fix whatever is happening when trying to punch the pot during an uppercut-punch
		if (player.pflags & PF_THOKKED) and player.caceepunch then
			player.cmd.buttons = $ &~ BT_JUMP
		end
		]]
	end
end
addHook("PreThinkFrame", caceebattleprethink)

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if solchars and not solchars["cacee"] then solchars["cacee"] = {SKINCOLOR_BURNING1, 2} end
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle
	
	//Priorities
	--[[
	local function ThePUNCH(cacee, enemy) -- Hey look, ma. It's a custom sweet spot!
		if abs(B.GetCollideRelativeAngle(cacee, enemy, true)) > ANGLE_67h
		and not (enemy and enemy.valid and enemy.battleobject and not enemy.sentient)
			return false
		else
			return true
		end
	end
	]]
	
	local function SpikeyBody(cacee, enemy) -- Another one, because bashables
		if enemy and enemy.valid and enemy.battleobject and not enemy.sentient then
			return false
		elseif enemy and enemy.valid and enemy.skin == "cacee" then
			return false
		else
			return true
		end
	end
	
	--B.AddPriorityFunction("cacee_punch", ThePUNCH)	-- Add the custom sweet spot for Cacee's punches.
	B.AddPriorityFunction("cacee_spikey", SpikeyBody)
	
	local function GarbagePriority5(player)
		if player.caceepunch == 3 then -- Punch Combo Finisher.
			CBW_Battle.SetPriority(player, 1, 0, "amy_melee", 2, 1, "Spike Rush finisher")
		elseif player.caceepunch then -- Punch Combo.
			CBW_Battle.SetPriority(player, 1, 0, "amy_melee", 1, 1, "Spike Rush combo")
		elseif player.mo.state == S_PLAY_TWINSPIN then -- SHORYUKEN.
			CBW_Battle.SetPriority(player, 1, 0, "tails_fly", 2, 2, "Rising Upper")
		end
		
		if (not player.battle_atk and not player.battle_def and not player.tumble
		and player.battle_sfunc == "can_damage" and not P_PlayerInPain(player)
		and (player.panim < PA_PAIN or (player.panim >= PA_JUMP or player.panim <= PA_FALL)))
		or player.caceepunch >= 4 -- Don't touch the cactus, man. Unless you can handle the prickling.
		then
			CBW_Battle.SetPriority(player, 0, 0, "cacee_spikey", 1, 0, "spikey cactus body")
		end
	end
	
	//Collision
	local CaceeCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,angle,thrust,thrust2,collisiontype)
		if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE
		and mo[n2] and mo[n2].valid and mo[n2].battleobject)
		or P_PlayerInPain(plr[n1]) or plr[n1].panim == PA_PAIN
		or not ((plr[n1].caceepunch and plr[n1].caceepunch <= 3)
		or mo[n1].state == S_PLAY_TWINSPIN) or not (mo[n1].health)
			return false
		end
		
		//Apply XY-Thrust
		local speedlimit = 48
		if mo[n2].health and plr[n1].caceepunch then
			if plr[n2] and P_PlayerInPain(plr[n2])
				mo[n2].momx = 0
				mo[n2].momy = 0
			end
			P_Thrust(mo[n2],R_PointToAngle2(mo[n1].x-mo[n1].momx,mo[n1].y-mo[n1].momy,mo[n2].x-mo[n2].momx,mo[n2].y-mo[n2].momy),
			FixedMul(B.GetLaunchFactor(plr[n1].speed/2), FixedDiv(weight[n1], weight[n2])))
		end
		
		//Apply Z-Thrust
		if not(pain[n2]) then 
			mo[n2].momz = -1*$+max(
				-speedlimit/2*mo[n2].scale,
				min(
					speedlimit/2*mo[n2].scale,
					FixedMul(
						B.GetLaunchFactor(mo[n1].momz),
						FixedDiv(
							weight[n1],
							weight[n2]
						)
					)
				)
			) //can i make this less messy???
			if mo[n1].state == S_PLAY_TWINSPIN
				mo[n2].momz = P_MobjFlip(mo[n1])*abs($)
			end
		end
		
		S_StartSound(mo[n2], sfx_cehit1)
		punchknockback(plr[n1], mo[n2])
		return true
	end

	local CaceePostCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain)
		--prevent infinite uppers on bashables, collide with them more often on punch
		if mo[n1].skin == "cacee" and mo[n2].battleobject then
			if mo[n1].state == S_PLAY_TWINSPIN then
				plr[n1].pflags = $|PF_THOKKED
			elseif plr[n1].caceepunch then
				plr[n1].caceethrust = 0
				mo[n1].pushtics = 2
				mo[n2].pushtics = mo[n1].pushtics
			end
		end
		--opponent is not a player or is guarding, don't flinch them
		if (not plr[n2]) or plr[n2].guardtics > 0 then
			return
		end
		--flinch time teehee
		if plr[n1].caceepunch == 2 and not hurt then
			local thrust = mo[n1].scale * 69/12
			CBW_Battle.DoPlayerFlinch(plr[n2], TICRATE/3, mo[n1].angle, thrust, false)
			P_Thrust(mo[n2], mo[n1].angle, mo[n1].scale * 69/12)
		end
	end
	
	//Ability
	local function CaceeBattle(mo,doaction)
		local player = mo.player
		local cooldown = TICRATE*5
		player.actiontext = "Pot of Pain"
		player.actionrings = 10
		if player.caceepot and player.caceepot.valid
			player.actionrings = 0
			--player.actiontext = "\x82" + $
			player.actiontext = "Relent"
		elseif not P_IsObjectOnGround(mo)
			player.actionrings = 0
			player.actiontext = "\x86" + $
		end
		
		if player.actiontime == 69 and not (player.caceepot
		and player.caceepot.valid and player.caceepot.health)
			S_StartSound(mo, sfx_jshard, player)
			B.ApplyCooldown(player,cooldown)
			player.actiontime = 0
		end

		if not(B.CanDoAction(player))
			player.actionstate = 0 --Default action state
		return end
			
		if player.actionstate == 0
		and doaction == 1
		and P_IsObjectOnGround(mo)
		and not (player.caceepot and player.caceepot.valid)
			local thokmobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			thokmobj.radius = FixedMul(mobjinfo[MT_CACEE_POT].radius, mo.scale)
			thokmobj.height = FixedMul(mobjinfo[MT_CACEE_POT].height, mo.scale)
			thokmobj.flags2 = $|MF2_DONTDRAW
			thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING

			if P_TryMove(thokmobj, mo.x+FixedMul(64*cos(mo.angle), mo.scale),
			mo.y+FixedMul(64*sin(mo.angle), mo.scale), true)
			and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
			and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
				local foundmobj = 0
				--[[
				searchBlockmap("objects", function(refmobj, mobj)
					if not (mobj and mobj.valid and mobj.health
					and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID))
					or R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius
					or refmobj.z - refmobj.scale > mobj.z + mobj.height
					or refmobj.z + refmobj.height + refmobj.scale < mobj.z
						return
					end
					
					foundmobj = mobj
				end, thokmobj)
				]]

				if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height
					S_StartSound(mo, sfx_s3k8c, player)
				else
					player.caceepot = P_SpawnMobjFromMobj(thokmobj, 0, 0, 0, MT_CACEE_POT)
					player.caceepot.color = player.skincolor
					local g = P_SpawnGhostMobj(player.caceepot)
					g.frame = E
					g.blendmode = AST_ADD
					g.destscale = player.caceepot.scale * 2
					g.scalespeed = g.destscale / g.tics
					if G_GametypeHasTeams() then
						player.caceepot.color = player.ctfteam == 1 and SKINCOLOR_SUPERRED5 or SKINCOLOR_ARCTIC
					end
					player.caceepot.therealcacee = player.mo
					B.PayRings(player)
					B.ApplyCooldown(player,TICRATE)
					player.actiontime = 69
				end
			else
				thokmobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
				P_TryMove(thokmobj, mo.x+FixedMul(64*cos(mo.angle), mo.scale),
				mo.y+FixedMul(64*sin(mo.angle), mo.scale), true)
				S_StartSound(mo, sfx_s3k8c, player)
			end
			caceecircle(thokmobj, MT_DUST, 16, 4*thokmobj.scale,
			0, thokmobj.scale, false, 0, false, thokmobj.angle)
			S_StartSound(mo, sfx_s3k52)
		elseif doaction == 1
			if (player.caceepot and player.caceepot.valid) then
				player.caceepot.health = 0
			end
			S_StartSound(mo, sfx_s3k8c, player)
		end
	end
	
	//Stats
	B.SkinVars["cacee"] = {
		weight = 70,
		guard_frame = 1,
		special = CaceeBattle,
		func_priority_ext = GarbagePriority5,
		func_collide = CaceeCollide,
		func_postcollide = CaceePostCollide,
	}
	
	if SKINVARS_NOSPINSHIELD
		B.SkinVars["cacee"].flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD
	end
end)

//Behavior when damaging other players (guess this works for Match too?)
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.player and mo.player.guard != 1 and mo.player.guard != 2
	and inf and inf.valid and inf.skin == "cacee" and inf.player
		local angle = R_PointToAngle2(mo.x,mo.y,inf.x-inf.momx,inf.y-inf.momy)
		
		if inf.player.battle_hurttxt == "spikey cactus body"
			S_StartSound(mo, sfx_cehit2)
		elseif ((inf.player.caceepunch and inf.player.caceepunch <= 3)
		or inf.state == S_PLAY_TWINSPIN)
			S_StartSound(mo, sfx_cehit1)
			punchknockback(inf.player, mo)
		end
	end
end, MT_PLAYER)

local teehee = function(mo) if mo.valid and P_IsObjectOnGround(mo) then mo.caceeupdrafted = false end end
addHook("MobjThinker", teehee, MT_PLAYER)

--TODO: remove after battlemod v10 is out lol
local PlayerCorkDamageSWEETSPOT = function(pmo,mo,source)
	if pmo.skin != "cacee" then
		return
	end
	local B = CBW_Battle
	if not(B and B.VersionNumber and B.VersionNumber < 10) then
		return
	end
	if not(mo and mo.valid
		and mo.blockable != nil
		and mo.flags&MF_MISSILE)
		return
	end
	if pmo.player and source and source.valid and source.player and not(B.MyTeam(source.player,pmo.player)) and not P_PlayerInPain(pmo.player)
		local vulnerable = B.PlayerCanBeDamaged(pmo.player)
		--B.PlayerCreditPusher(pmo.player,source)
		
		local hthrust = mo.block_hthrust
		local vthrust = mo.block_vthrust
		local blockstun = mo.block_stun
		local sound = sfx_s3k7b
		if mo.block_sound
			sound = mo.block_sound
		end
	
		local func = pmo.player.battle_sfunc and B.PriorityFunction[pmo.player.battle_sfunc] or 0
		--local blocked = pmo.player.battle_def >= mo.blockable
		local sweetspot_blocked = func and func(pmo, mo) and pmo.player.battle_sdef >= mo.blockable
		
		if vulnerable and (blocked or sweetspot_blocked) then
			B.ResetPlayerProperties(pmo.player,false,false)
			
			if P_IsObjectOnGround(pmo) then
				P_InstaThrust(pmo,mo.angle,mo.scale*hthrust)
				pmo.state = S_PLAY_SKID
			else
				pmo.momz = $/2
				B.ZLaunch(pmo, mo.scale*vthrust, true)
				P_InstaThrust(pmo,mo.angle,mo.scale*hthrust / 2)
			end
			
			S_StartSound(pmo,sound)
				
			//Do flinch, uncurl
			local angle = R_PointToAngle2(0,0,pmo.momx,pmo.momy)
			local recoilthrust = FixedHypot(pmo.momx,pmo.momy)
			B.DoPlayerFlinch(pmo.player, blockstun, angle, recoilthrust)
			P_RemoveMobj(mo)
			return false
		--[[
		elseif not(vulnerable) then
			if P_IsObjectOnGround(pmo) then
				P_Thrust(pmo,mo.angle,mo.scale*hthrust / 2)
			else
				pmo.momz = $ * 3/4
				B.ZLaunch(pmo, mo.scale*vthrust/2, true)
				P_Thrust(pmo,mo.angle,mo.scale*hthrust / 4)
			end
			S_StartSound(pmo,sound)
			return false
		]]
		end
		
		--return true
	end
end
addHook("ShouldDamage",PlayerCorkDamageSWEETSPOT,MT_PLAYER)